Package: rerddapUtils
Title: Miscellaneous Utilities for 'rerddap'
Version: 1.0.2
Date: 2026-06-05
Authors@R: person("Roy", "Mendelssohn", email = "roy.mendelssohn@noaa.gov", role = c("aut","cre"))
Description: The 'rerddapUtils' package is an 'R' package that is a set of four main
 functions designed to work with and extend the 'rerddap' package. These functions includes one for restricting by season,
 one for splitting large requests, and two for working with projected datasets. There are also two utility functions
 that provide estimates of the size of a proposed 'rerddap::griddap()' request.
License: CC0
Encoding: UTF-8
Depends: R(>= 4.4.0)
Imports: cli, DBI, duckdb, lubridate, ncdf4, rerddap, sf, stats,
        stringr,
Suggests: arrow, dplyr, duckplyr, httr, knitr, rmarkdown
VignetteBuilder: knitr
Config/roxygen2/version: 8.0.0.9000
LazyData: true
NeedsCompilation: no
Packaged: 2026-06-07 16:59:08 UTC; rmendels
Author: Roy Mendelssohn [aut, cre]
Maintainer: Roy Mendelssohn <roy.mendelssohn@noaa.gov>
Repository: CRAN
Date/Publication: 2026-06-08 06:50:08 UTC
Built: R 4.6.0; ; 2026-06-08 08:32:03 UTC; unix

Package: rerddapUtils
Title: Miscellaneous Utilities for 'rerddap'
Version: 1.0.2
Date: 2026-06-05
Authors@R: person("Roy", "Mendelssohn", email = "roy.mendelssohn@noaa.gov", role = c("aut","cre"))
Description: The 'rerddapUtils' package is an 'R' package that is a set of four main
 functions designed to work with and extend the 'rerddap' package. These functions includes one for restricting by season,
 one for splitting large requests, and two for working with projected datasets. There are also two utility functions
 that provide estimates of the size of a proposed 'rerddap::griddap()' request.
License: CC0
Encoding: UTF-8
Depends: R(>= 4.4.0)
Imports: cli, DBI, duckdb, lubridate, ncdf4, rerddap, sf, stats,
        stringr,
Suggests: arrow, dplyr, duckplyr, httr, knitr, rmarkdown
VignetteBuilder: knitr
Config/roxygen2/version: 8.0.0.9000
LazyData: true
NeedsCompilation: no
Packaged: 2026-06-07 16:59:08 UTC; rmendels
Author: Roy Mendelssohn [aut, cre]
Maintainer: Roy Mendelssohn <roy.mendelssohn@noaa.gov>
Repository: CRAN
Date/Publication: 2026-06-08 06:50:08 UTC
Built: R 4.6.0; ; 2026-06-08 07:09:40 UTC; unix

# rerddapUtils (Version 1.0.0)


 `rerddapUtils` is an `R` package that is a set of four main 
 functions designed to work with and extend the `rerddap` package
 to provide capabilities requested by users that meet specialized needs 
 which are better not being included in the `rerddap` package.
 
 The first function is:
 
- `griddap_season <- function(datasetx, ..., fields = 'all', stride = 1, season = NULL, fmt = "nc", url = rerddap::eurl(), store = rerddap::disk(), read = TRUE, callopts = list())`
                          
which will only extract data for the period during the year defined by 'season'.  The second function is:
  
  
- `griddap_split <- function(datasetx, ..., fields = 'all', stride = 1, request_split = NULL, fmt = "nc", url = rerddap::eurl(), store = rerddap::disk(), read = TRUE, callopts = list(), aggregate_file = NULL)`
              
which is designed to split a very large request into pieces defined by 'request_split' and then aggregate the parts either in memory,  in a duckdb database or in a netcdf4 file.  This allows for requests larger than 2GB to be made in an appropriate manner.
 
Note that `griddap_season()` and `griddap_split()` are designed to have basically the same interface as `rerddap::griddap()`,  except for one or two  extra function arguments and some arguments that are interpreted differently. In both functions the argument 'store = rerddap::disk()' is ignored.  In `griddap_season` the 'fmt' argument is ignored  while 'season' defines the days during the year to make the extract.

In  `griddap_split` the argument 'fmt' defines whether the aggregate download should be stored in memory as a dataframe,  in a duckdb database file,  or in a netcdf file.  For the duckdb and nectdf options, 'aggregate_file' lets you define where to write the file,  if not defined it will set up a temporary file following proper `R` guidelines and in both cases the path to the file will be returned.

The other two functions are designed to make it easier to work with projected datasets:

- `latlon_to_xy <- function (dataInfo, latitude, longitude, yName = 'latitude', xName = 'longitude', crs = NULL) `

which for a given dataset will convert a latitude and longitude request into the projected coordinates to be used in `rerddap::griddap()`, while the fourth function:

- `xy_to_latlon <- function (resp, yName = 'cols', xName = 'rows', crs = NULL)`

does the reverse,  given an `rerddap::griddap()` extract will convert the projected coordinates into latitude and longitude values.

There are also two helper functions to give a rough estimate of the size of an `rerddap` request:

-  `estimate_griddap_size <- function(info,  ..., fields  = "all", stride  = 1L, spacing = list(), verbose = TRUE)`

which estimates the size of a regular `rerddap` request, and:

-  `estimate_griddap_split_size <- function(size_est, splits, verbose = TRUE)`

which estimates the size of the proposed split for the function `griddap_split()`.

The vignette assumes familiarity with the various 'rerddap' functions and how to use them.  More information about the various 'rerddap' functions can be found in the documentation for that package.

## Installation

You can install the development version of rerddapUtils from Github:

``` r
remotes::install_github("rmendels/rerddapUtils")
```

More detail and examples can be found in the Vignette.

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(arrow)
library(dplyr)
library(duckdb)
library(duckplyr)
library(lubridate)
library(ncdf4)
library(rerddap)
library(rerddapUtils)

## ----test_season_time---------------------------------------------------------
year <- '2023'
season <- c('02-01', '06-01')
# test that "season" is defined properly
test_time <- paste0(year, '-', season)
lubridate::as_datetime(test_time)

## ----wind_extract, eval=FALSE-------------------------------------------------
# wind_info <- rerddap::info('erdQMekm14day')
# extract <- rerddap::griddap(wind_info,
#                             time = c('2015-01-01','2019-01-01'),
#                             latitude = c(20, 40),
#                             longitude = c(220, 240),
#                             fields = 'mod_current'
# )

## ----wind_season, eval = FALSE------------------------------------------------
# wcnURL <- "https://coastwatch.pfeg.noaa.gov/erddap/"
# wind_info <- rerddap::info('erdQMekm14day', url = wcnURL)
# season <- c('03-01', '05-01')
# season_extract <- griddap_season(wind_info,
#  time = c('2015-01-01','2019-01-01'),
#  latitude = c(20, 40),
#  longitude = c(220, 240),
#  fields = 'mod_current',
#  season = season
# )
# 

## ----season_months, eval = FALSE----------------------------------------------
# extract_times  <- lubridate::as_datetime(season_extract$data$time)
# extract_months <- lubridate::month(extract_times)
# unique(extract_months)

## ----request_split------------------------------------------------------------
request_split <- list(time = 5, altitude = 1, latitude = 2, longitude = 2)

## ----request_split_fail, eval = FALSE-----------------------------------------
# request_split <- list(time = 5, latitude = 2, longitude = 2)

## ----wind_extract_redux, eval=FALSE-------------------------------------------
# wind_info <- rerddap::info('erdQMekm14day')
# extract <- rerddap::griddap(wind_info,
#                             time = c('2015-01-01','2016-01-01'),
#                             latitude = c(20, 40),
#                             longitude = c(220, 240),
#                             fields = 'mod_current'
# )

## ----wind_extract_size, eval = FALSE------------------------------------------
# sz <- estimate_griddap_size(wind_info,
#                             time = c('2015-01-01','2016-01-01'),
#                             latitude = c(20, 40),
#                             longitude = c(220, 240),
#                             fields = 'mod_current',
# )
# 
# 

## ----wind_extract_split_size, eval = FALSE------------------------------------
# estimate_griddap_split_size(sz,
#  splits = request_split
#  )
# 

## ----wind_split_memory, eval = FALSE------------------------------------------
# wcnURL <- "https://coastwatch.pfeg.noaa.gov/erddap/"
# wind_info <- rerddap::info('erdQMekm14day', url = wcnURL)
# request_split <- list(time = 5, altitude = 1, latitude = 2, longitude = 2)
# split_extract <- griddap_split(wind_info,
#  time = c('2015-01-01','2016-01-01'),
#  latitude = c(20, 40),
#  longitude = c(220, 240),
#  fields = 'mod_current',
#  request_split = request_split,
#  fmt = "memory"
# )
# str(split_extract)

## ----wind_split_nc, eval = FALSE----------------------------------------------
# wcnURL <- "https://coastwatch.pfeg.noaa.gov/erddap/"
# wind_info <- rerddap::info('erdQMekm14day', url = wcnURL)
# request_split <- list(time = 5, altitude = 1, latitude = 2, longitude = 2)
# split_extract <- griddap_split(wind_info,
#  time = c('2015-01-01','2016-01-01'),
#  latitude = c(20, 40),
#  longitude = c(220, 240),
#  fields = 'mod_current',
#  request_split = request_split,
#  fmt = "nc"
# )
# 

## ----wind_split_nc_named, eval=FALSE------------------------------------------
# 
# wind_info <- rerddap::info('erdQMekm14day')
# request_split <- list(time = 5, altitude = 1, latitude = 2, longitude = 2)
# split_extract <- griddap_split(wind_info,
#  time = c('2015-01-01','2016-01-01'),
#  latitude = c(20, 40),
#  longitude = c(220, 240),
#  fields = 'mod_current',
#  request_split = request_split,
#  fmt = "nc",
#  aggregate_file = 'wind_extract.nc'
# )
# 

## ----wind_split_read_nc, eval = FALSE-----------------------------------------
# wind_file <- ncdf4::nc_open(split_extract )
# wind_file
# ncdf4::nc_close(wind_file)
# 

## ----wind_split_duckdb, eval = FALSE------------------------------------------
# 
# wind_info <- rerddap::info('erdQMekm14day')
# request_split <- list(time = 5, altitude = 1, latitude = 2, longitude = 2)
# split_extract <- griddap_split(wind_info,
#  time = c('2015-01-01','2016-01-01'),
#  latitude = c(20, 40),
#  longitude = c(220, 240),
#  fields = 'mod_current',
#  request_split = request_split,
#  fmt = "duckdb",
#  aggregate_file = 'wind_extract.duckdb'
# )
# 

## ----wind_split_read, eval = FALSE--------------------------------------------
# con_db <- dbConnect(duckdb::duckdb(), "wind_extract.duckdb")
# tbl(con_db, "extract") |>
#      head(5) |>
#      collect()
# dbDisconnect(con_db, shutdown=TRUE)

## ----wind_split_parquet, eval = FALSE-----------------------------------------
# con_db <- dbConnect(duckdb::duckdb(), "wind_extract.duckdb")
# # Use DuckDB's COPY command to write directly to Parquet file without loading into R
# query <- sprintf("COPY extract TO '%s' (FORMAT 'parquet')", "wind_extract.parquet")
# DBI::dbExecute(con_db, query)
# dbDisconnect(con_db, shutdown=TRUE)

## ----proj_strings, eval = FALSE-----------------------------------------------
#    proj_strings <- c('proj4text', 'projection', 'proj4string', 'grid_mapping_epsg_code',
#                     'WKT',  'proj_crs_code',
#                     'grid_mapping_epsg_code', 'grid_mapping_proj4',
#                     'grid_mapping_proj4_params', 'grid_mapping_proj4text')
# 

## ----bounding_box-------------------------------------------------------------
latitude <- c( 80., 85.)
longitude <- c(-170., -165)


## ----latlon_to_xy, eval = FALSE-----------------------------------------------
# myURL <- 'https://coastwatch.noaa.gov/erddap/'
# myInfo <- rerddap::info('noaacwVIIRSn20icethickNP06Daily', url = myURL)
# coords <- latlon_to_xy(myInfo,  longitude, latitude)
# coords

## ----xy_to_latlon, eval = FALSE-----------------------------------------------
# rows <- c( -889533.8, -469356.9)
# cols <- c(622858.3, 270983.4)
# myURL <- 'https://coastwatch.noaa.gov/erddap/'
# myInfo <- rerddap::info('noaacwVIIRSn20icethickNP06Daily', url = myURL)
# proj_extract <- rerddap::griddap(myInfo,
#                                   time = c('2023-01-30T00:00:00Z', '2023-01-30T00:00:00Z'),
#                                   rows = rows,
#                                   cols = cols,
#                                   fields = 'IceThickness',
#                                   url = myURL
#   )
# test <- xy_to_latlon(proj_extract)
# head(test)
# 

#' Title Get ERDDAP gridded data restricted to a given season of the year
#'
#' \code{griddap_season} uses the R program 'rerddap::griddap()' to extract environmental data
#' from an 'ERDDAP' server in an (time, z, y ,x) bounding box where time is restricted to a
#' given season of the year  (see below).  Arguments are the same as in 'rerddap::griddap()'
#' except for the added 'season' parameter.  'read' and 'fmt' options are ignored.
#' @param datasetx Anything coercable to an object of class info. So the output of a
#' call to \code{\link[rerddap]{info}}, or a datasetid, which will internally be passed
#' through \code{\link[rerddap]{info}}
#' @param ... Dimension arguments. See examples. Can be any 1 or more of the
#' dimensions for the particular dataset - and the dimensions vary by dataset.
#' For each dimension, pass in a vector of length two, with min and max value
#' desired. at least 1 required.
#' @param fields (character) Fields to return, in a character vector.
#' @param stride (integer) How many values to get. 1 = get every value, 2 = get every other value, etc.
#'                Default: 1 (i.e., get every value)
#' @param request_split A numeric vector indicating the number of splits for each dimension, used
#'   to segment the request into manageable chunks. This is particularly useful for large datasets.
#' @param fmt (character) One of:
#' -  nc: save output to a netcdf file
#' -  memory:  save output in a dataframe in memory
#' -  duckdb:  save data in a duckdb database
#' @param url A URL for an ERDDAP server. Default:
#' https://upwell.pfeg.noaa.gov/erddap/ - See [rerddap::eurl()] for
#' more information
#' @param store ignored
#' @param read ignored
#' @param callopts Curl options passed on to \code{\link[crul]{verb-GET}}
#' @param aggregate_file A string specifying:
#'  - if is.null(aggregate_file) then a temporary file is created that does not
#'       overwrite user space
#'  - if "fmt = nc" the path to the NetCDF file to store the results
#'  - if "fmt = duckdb" the path to the duckdb file to store the results
#'  - if "fmt = memory" the value is ignored
#' @return Varies by format requested:
#'  - if "fmt = nc" the path to the NetCDF file where the results are stored
#'  - if "fmt = duckdb" the path to the duckdb file where the results are stored
#'  - if "fmt = memory" the usual rerddap::griddap dataframe
#' @export
#'
#' @examples
#' myURL <- "https://coastwatch.pfeg.noaa.gov/erddap/"
#' response <- try(httr::HEAD(myURL, httr::timeout(20)), silent = TRUE)
#' if (inherits(response, "try-error")) {
#'   message("The ERDDAP\u2122 server is not responding")
#' } else
#' {
#' data(wind_info)
#' request_split <- list(time = 2, altitude = 1, latitude = 1, longitude = 1)
#' res <- try(griddap_split(wind_info,
#'                      time = c('2015-12-31','2016-01-01'),
#'                      latitude = c(20, 21),
#'                      longitude = c(220, 221),
#'                      fields = 'mod_current',
#'                      request_split = request_split
#'                      ), silent = TRUE)
#' if (inherits(res, "try-error")) {
#'    message("Unable to retrieve data from the ERDDAP\u2122 server")
#'    }
#' }
griddap_split <- function(datasetx, ..., fields = 'all', stride = 1, request_split = NULL, fmt = "nc",
                    url = rerddap::eurl(), store = rerddap::disk(),
                    read = TRUE, callopts = list(), aggregate_file = NULL) {

  x <- datasetx
  if (is.null(request_split)) {
    #print('no split is given')
    #print('this must be a vector the same length of the number of dimensions')
    #print('each elementof the vector is the number of splits in that dimension')
    #stop('stopped on error')
    cli::cli_abort(c(
      "{.arg split} must be provided.",
      "i" = "It must be a vector the same length as the number of dimensions.",
      "i" = "Each element is the number of splits for that dimension."
    ))
  }
  if ( (fmt == 'nc') | (fmt == 'duckdb')) {
    if (!is.null(aggregate_file )) {
      file_check <- file.exists(aggregate_file)
      if (file_check) {
        #print('aggregate file already exists')
        #print('either rename the exising file or change aggregate_file')
        #stop('program is stopping')
        cli::cli_abort(c(
          "Aggregate file already exists: {.path {aggregate_file}}",
          "i" = "Rename the existing file or choose a different {.arg aggregate_file}."
        ))
      }
    }
  }
  dimargs <- list(...)
  if (length(dimargs) == 0) stop("no dimension arguments passed, see ?griddap")
  if (inherits(x, "info")) {
    url <- x$base_url
    message("info() output passed to x; setting base url to: ", url)
  } else {
    x <- rerddap::as.info(x, url)
  }
  if (attr(x, "type") != "griddap")
    stop("datasetid '", attr(x, "datasetid"), "' not of type griddap")
  check_dims(dimargs, x)
  if (!is.null(dimargs$time)) {
    check_time_range(dimargs, x)
  }
  call_list <- extract_rerddap_call(x, dimargs, stride, fields, url)
  dimargs <- call_list$dimargs
  dim_args <- call_list$dim_args
  dimVals <- call_list$dimVals
  url_base <- call_list$url_base
  fields <- call_list$fields
  nc_file <- call_list$nc_file
  split_dim <- define_split(dimVals, request_split)
  extract <- split_griddap_request(x, url, stride,
                                    request_split, split_dim, fields, fmt,
                                    callopts, nc_file, aggregate_file)
  return(extract)
}



# Split and Process 'rerddap::griddap()' Requests
#
# This function handles splitting and processing requests to the `rerddap::griddap()` service,
# facilitating the handling of large datasets by dividing the requests into manageable parts.
# It supports output in different formats, including NetCDF ('nc') and DuckDB ('duckdb'), and
# performs the necessary operations to aggregate the results into a single file or database.
#
# @param info An object containing the dataset information, typically obtained from a call to
#  `rerddap::info()` or similar function that provides metadata about the dataset.
# @param url The base URL of the ERDDAP server from which to fetch the data.
# @param stride An integer indicating the stride (step size) for the query, allowing for
#   data thinning to reduce the volume of data retrieved.
# @param request_split A numeric vector indicating how to split the dataset query along each
#   dimension to manage large datasets more effectively.
# @param split_dim A named list where each name corresponds to a dimension in the dataset and
#   the values indicate how to split each dimension for the request.
# @param fields A character vector specifying which fields (variables) to retrieve from the
#   dataset. A value of 'all' indicates that all available fields should be included.
# @param fmt The format of the output, with supported values including 'nc' for NetCDF files
#   and 'duckdb' for DuckDB database format.
# @param aggregate_file The path to the output file or database where the aggregated results
#   from the split requests should be stored.
#
# @return Depending on the `fmt`, either the path to the aggregated NetCDF file or the DuckDB
#   database file containing the data retrieved and processed from the split requests.
#
split_griddap_request <- function(info, url, stride,
                                  request_split, split_dim, fields,  fmt,
                                  callopts, nc_file, aggregate_file) {
  # if fmt is duckdb,  open the connection
  con_db <- NULL
  if (fmt == 'duckdb') {
    if (is.null(aggregate_file)) {
      aggregate_file <- tempfile("extract", tmpdir = tempdir(), fileext = '.duckdb')
    }
    drv <- duckdb::duckdb()
    con_db <- duckdb::dbConnect(drv, aggregate_file)
  }
  # if fmt is netcdf,  create new netcdf file and copy attributes
  if (fmt == 'nc') {
    if (is.null(aggregate_file)) {
      aggregate_file <- tempfile("extract", tmpdir = tempdir(), fileext = '.nc')
    }
    return <- create_nc_file(info, fields, nc_file, aggregate_file )
    return <- copy_attributes(info, fields, nc_file, aggregate_file)
  }
  griddapOptsNames <- c('datasetx',  names(split_dim), 'fields', "stride", "callopts")
  split_names <- names(split_dim)
  final_result <- NULL
  griddapOpts <- list(info)
  final_result <- recursive_extract(1, request_split, split_dim, griddapOpts,
                                    stride, callopts, final_result,
                                    info, fields, fmt, con_db, aggregate_file)
  if (fmt == 'duckdb') {
    duckdb::dbDisconnect(con_db, shutdown = TRUE)
    duckdb::duckdb_shutdown(drv)
    final_result <- aggregate_file
  } else if (fmt == 'nc') {
    final_result <- aggregate_file
  }
  return(final_result)
}


# Recursively Split and Extract Data Requests
#
# This function is designed to recursively split and process data requests based on specified
# dimensions and constraints. It is particularly useful for managing large datasets or requests
# that need to be broken down into smaller chunks to comply with server limitations or to
# optimize data retrieval. The function iterates through each dimension, applies constraints,
# and accumulates the results.
#
# @param level The current level of recursion, indicating the dimension being processed.
# @param request_split A vector specifying the number of splits for each dimension of the data
#   request. The length of this vector should match the number of dimensions in the dataset.
# @param split_dim A named list where each name corresponds to a dimension and each value
#   specifies the splitting criteria for that dimension.
# @param griddapOpts A list of options for the `rerddap::griddap()` call, modified recursively
#   to reflect the current split criteria.
# @param stride The stride (step size) for the data retrieval, which can help reduce the volume
#   of data retrieved by skipping over points.
# @param callopts A list of additional options to pass to the HTTP request function, useful for
#   configuring details such as timeouts or proxy settings.
# @param final_result An accumulator for the results from each recursive call, which can be
#   aggregated or processed further.
# @param info Dataset information, typically obtained from a call to `rerddap::info()` or a
#   similar function, providing metadata about the dataset.
# @param fields Specifies which fields (variables) to retrieve from the dataset. Can be 'all'
#   for retrieving all fields or a vector of specific field names.
# @param fmt The format of the output, which can influence how results are stored or aggregated.
# @param con_db A connection object for database formats (e.g., DuckDB) when `fmt` is set to
#   a database format. This parameter is used to manage database connections during data extraction.
# @param aggregate_file The path to the file where aggregated results should be stored, applicable
#   when data is being compiled into a single file.
#
# @return The final aggregated result of the data extraction process, the specifics of which
#   depend on the `fmt` parameter and the nature of the `final_result` accumulation.
#
recursive_extract <- function(level, request_split, split_dim, griddapOpts,
                              stride, callopts, final_result,
                              info, fields, fmt, con_db, aggregate_file) {
  split_names <- names(split_dim)

  # Base case: If the level exceeds the length of request_split, perform the extraction
  if (level > length(request_split)) {
    final_result <- partial_extract(fields, fmt, griddapOpts,  stride, callopts,
                                    final_result, con_db, aggregate_file)
    return(final_result)
  }

  # Recursive step: Iterate over the current dimension
  temp_name <- split_names[level]
  for (i in seq(1, request_split[[level]])) {
    temp_value <- get_dim_constraint(request_split, split_dim, level, i)
    griddapOpts[[temp_name]] <- temp_value
    # Recurse to the next level with updated griddapOpts
    final_result <- recursive_extract(level + 1, request_split, split_dim, griddapOpts,
                                      stride, callopts, final_result,
                                      info, fields, fmt, con_db, aggregate_file)
  }

  return(final_result)
}


# Perform a Partial Data Extraction and Aggregation
#
# This function facilitates a portion of the data extraction process from a `rerddap::griddap()` call,
# handling specific fields and formatting options. It supports aggregating the extracted data into
# various formats such as in-memory objects, DuckDB, or NetCDF files, based on the specified format.
#
# @param fields The fields (variables) to be extracted from the dataset.
# @param fmt The format for aggregating the extracted data: 'memory', 'duckdb', or 'nc' (NetCDF).
# @param griddapOpts A list of options for the `rerddap::griddap()` call, including dataset ID,
#   dimensions, and any other parameters necessary for the data request.
# @param stride An integer specifying the stride (step size) for the data retrieval, useful for
#   thinning the data.
# @param callopts A list of additional options to customize the HTTP request made by `rerddap::griddap()`.
# @param final_result An accumulator for the results, which varies based on the specified format. For
#   'memory', this would be a data structure holding the aggregated data; for 'duckdb' or 'nc', it might
#   not be directly used.
# @param con_db A connection object for the DuckDB database, used when `fmt` is 'duckdb'.
# @param aggregate_file The file path for storing the aggregated results when `fmt` is 'nc'.
#
# @return Depending on the specified `fmt`, returns the aggregated data in the chosen format. For
#   'memory', it returns the aggregated data structure; for 'duckdb', it may return the connection
#   object or an indication of success; for 'nc', it may return the path to the NetCDF file or an
#   indication of success.
#
partial_extract <- function(fields, fmt,  griddapOpts, stride, callopts,
                            final_result, con_db, aggregate_file) {
  names(griddapOpts)[1] <- 'datasetx'
  griddapOpts$fields <- fields
  griddapOpts$stride <- stride
  griddapOpts$callopts <- callopts
  extract <- suppressMessages(do.call(rerddap::griddap, griddapOpts))
  if (fmt == 'memory') {
    final_result <- aggregate_memory(extract, final_result)
  } else if (fmt == 'duckdb') {
    final_result <- aggregate_duckdb(extract, con_db)
  } else if (fmt == 'nc') {
    final_result <- aggregate_netcdf(extract, aggregate_file)
  }
  return(final_result)
}



# Calculate Dimension Constraints for Data Retrieval Requests
#
# This function determines the constraints for a specific dimension of a dataset, based on the
# provided splitting criteria. It's designed to support segmented data retrieval operations by
# calculating the subset bounds for each segment of the request. This is particularly useful in
# the context of large dataset queries where requests may need to be split to avoid server
# limitations or to manage memory more efficiently.
#
# @param request_split A numeric vector indicating the number of splits for each dimension of
#   the data request. The length of this vector should match the number of dimensions in the dataset.
# @param split_dim A list where each element corresponds to a dimension in the dataset and contains
#   the full range of values for that dimension. The list's names should match the dimension names.
# @param var_index The index (integer) of the variable within `split_dim` for which the constraint
#   is being calculated.
# @param loop_index The index (integer) within the specified split of the dimension to calculate
#   the constraint for. This helps identify the specific segment of the split dimension.
#
# @return A numeric vector of length two, representing the lower and upper bounds of the constraint
#   for the specified dimension segment. If the dimension is not split (`request_split[var_index] == 1`),
#   it returns the full range for that dimension.
#
get_dim_constraint <- function(request_split, split_dim, var_index,  loop_index){
  split_names <- names(split_dim)
  temp_name <- split_names[var_index]
  if(request_split[var_index] == 1) {
    temp_value <- split_dim[[var_index]]
    temp_value <- unlist(temp_value)
    temp_value <- c(temp_value[1], temp_value[length(temp_value)])
  } else {
    temp_value <- split_dim[[var_index]]
    temp_value <- temp_value[loop_index]
    temp_value <- unlist(temp_value, use.names=FALSE)
    temp_value <- c(temp_value[1], temp_value[length(temp_value)])
  }
  return(temp_value)
}

# Define Splits for Dimension Values Based on Requested Segments
#
# This function calculates and organizes the splits for each dimension of a dataset based on the
# specified number of segments. It is useful for preparing segmented data retrieval requests,
# particularly when working with large datasets or when server limitations necessitate breaking down
# requests into smaller chunks.
#
# @param dimVals A list where each element corresponds to a dimension in the dataset and contains
#   the full range of values for that dimension. The list's names should match the dimension names.
# @param request_split A numeric vector indicating the number of segments into which each dimension
#   should be split. The length of this vector should match the number of dimensions in `dimVals`.
#
# @return A list of the same structure as `dimVals`, where each dimension's values are further
#   organized into the specified number of segments. If a dimension is not to be split (`request_split`
#   value of 1), its original range is preserved.
#
define_split <- function(dimVals, request_split) {
  indices <- request_split > 1
  dim_splits <- list()
  for (i in seq_along(dimVals)) {
    temp_name <- names(dimVals)[i]
    temp_dim <- dimVals[[i]]
    no_cut <- request_split[[i]]
    if (no_cut == 1) {
      dim_splits[[temp_name]] <- temp_dim
    } else {
      dim_splits[[temp_name]] <- split(temp_dim, cut(seq_along(temp_dim), no_cut, labels = FALSE))
    }
  }
  return(dim_splits)
}

# Aggregate Extracted Data in Memory
#
# This function aggregates newly extracted data with an existing data structure in memory.
# It is designed to sequentially combine data extracts, typically used when data is being
# retrieved in segments and needs to be compiled into a single dataset.
#
# @param extract A data frame or list representing the newly extracted data to be aggregated.
#   This parameter is expected to have a structure compatible with `final_result`, particularly
#   in terms of column names and types if it's a data frame.
# @param final_result The current aggregate of previously extracted data. If `NULL`,
#   `extract` becomes the initial dataset for aggregation. This parameter should be a data
#   structure (e.g., a data frame or list) that can hold the combined result of successive
#   extractions.
#
# @return Returns an updated version of `final_result` that includes the data from `extract`.
#   If `final_result` was initially `NULL`, returns `extract`.
aggregate_memory <- function(extract, final_result){
  if (is.null(final_result)) {
    final_result <- extract
  } else {
    final_result$data <- rbind(final_result$data, extract$data)
  }
  return(final_result)
}

#Aggregate Extracted Data into a DuckDB Database
#
#This function facilitates the aggregation of newly extracted data into a DuckDB database.
#It checks if a table named 'extract' exists in the database and, depending on its presence,
#either creates the table and inserts the data or appends the data to an existing table.
#
#@param extract A data frame or list representing the newly extracted data to be aggregated
#  into the DuckDB database. This parameter should contain the actual data in a format
#  compatible with DuckDB table structures.
#@param con_db A DuckDB connection object created via `DBI::dbConnect()`. This connection
#  is used to interact with the DuckDB database for writing the extracted data.
#
#@return This function does not return a value but performs an operation that inserts or
#  appends data into a DuckDB database.
#
aggregate_duckdb <- function(extract, con_db){
  # Corrected function body with appropriate variable names
  query <- "SELECT table_name FROM information_schema.tables WHERE table_name = 'extract';"
  result <- DBI::dbGetQuery(con_db, query) # Corrected the connection object variable name
  table_exists <- nrow(result) > 0

  if (!table_exists) {
    DBI::dbWriteTable(con_db, "extract", extract$data)
  } else {
    DBI::dbWriteTable(con_db, "extract1", extract$data, append = TRUE)
    DBI::dbExecute(con_db, "INSERT INTO extract SELECT * FROM extract1")
    # Assuming cleanup is needed for the temporary table 'extract1'
    DBI::dbExecute(con_db, "DROP TABLE extract1")
  }
}



# Aggregate Extracted Data into a NetCDF File
#
# This function aggregates extracted data into an existing NetCDF file. It is particularly useful
# for sequentially adding data from multiple extracts into a single NetCDF file, handling
# alignment of dimensions and variables between the extract and the aggregate file. It supports
# time dimensions and other variables, converting time values appropriately if necessary.
#
# @param extract A list representing the newly extracted data, including metadata about the
#   extraction (e.g., file names, dimensions, variables). The `summary` element of this list
#   should contain the filename, dimensions (`dim`), and variables (`var`) of the extracted data.
# @param aggregate_file A string specifying the path to the NetCDF file into which the extracted
#   data should be aggregated. This file should already exist and be structured to accommodate
#   the extracted data.
#
# @return This function does not return a value but modifies the specified NetCDF file by
#   adding or updating data from the extract.
#
# @examples
# # Assuming `extract` contains the necessary structure and `aggregate_file` is the path to
# # your NetCDF file:
# aggregate_netcdf(extract, "path/to/your/aggregate_file.nc")
#
# # Note: This example assumes that `extract` and `aggregate_file.nc` are correctly prepared
# # and compatible. Actual usage will require specific setup of the NetCDF file and extracts.
#

aggregate_netcdf <- function(extract, aggregate_file) {
  extract_nc <- ncdf4::nc_open(extract$summary$filename)
  on.exit(ncdf4::nc_close(extract_nc), add = TRUE)
  root <- ncdf4::nc_open(aggregate_file, write = TRUE)
  on.exit(ncdf4::nc_close(root), add = TRUE)

  # Compute start/count indices for each dimension
  dim_indices <- lapply(names(extract$summary$dim), function(dim_name) {
    extract_vals <- extract$data[[dim_name]]
    if (dim_name == "time") {
      extract_vals <- as.numeric(lubridate::as_datetime(extract_vals))
    }
    file_vals <- ncdf4::ncvar_get(root, dim_name)
    idx <- which(file_vals >= min(extract_vals) & file_vals <= max(extract_vals))
    list(start = idx[1], count = length(idx))
  })

  #start <- rev(sapply(dim_indices, `[[`, "start"))
  #count <- rev(sapply(dim_indices, `[[`, "count"))
  start <- rev(vapply(dim_indices, `[[`, FUN.VALUE = numeric(1), "start"))
  count <- rev(vapply(dim_indices, `[[`, FUN.VALUE = numeric(1), "count"))
  # Write each field into the aggregate file
  lapply(names(extract$summary$var), function(field) {
    ncdf4::ncvar_put(root, field, ncdf4::ncvar_get(extract_nc, field),
                     start = start, count = count)
  })

  invisible(NULL)
}

#' Projected ice dataset response
#'
#' \code{rerddap::griddap()} call to Projected ice dataset
#'
#' @format A list of class \code{griddap_nc} with elements:
#' \describe{
#'   \item{data}{a data frame of the extracted ice values}
#'   \item{summary}{metadata summary}
#' }
#' @source \url{https://coastwatch.noaa.gov/erddap/}
#' @docType data
#' @name proj_extract
"proj_extract"

#' Title Get ERDDAP gridded data restricted to a given season of the year
#'
#' \code{griddap_season} uses the R program 'rerddap::griddap()' to extract environmental data
#' from an 'ERDDAP' server in an (time, z, y ,x) bounding box where time is restricted to a
#' given season of the year  (see below).  Arguments are the same in 'rerddap::griddap()'
#' except for the added 'season' parameter.  'read' and 'fmt' options are ignored.
#' @param datasetx Anything coercable to an object of class info. So the output of a
#' call to \code{\link[rerddap]{info}}, or a datasetid, which will internally be passed
#' through \code{\link[rerddap]{info}}
#' @param ... Dimension arguments. See examples. Can be any 1 or more of the
#' dimensions for the particular dataset - and the dimensions vary by dataset.
#' For each dimension, pass in a vector of length two, with min and max value
#' desired. at least 1 required.
#' @param fields (character) Fields to return, in a character vector.
#' @param stride (integer) How many values to get. 1 = get every value, 2 = get every other value, etc.
#'                Default: 1 (i.e., get every value)
#' @param season (character) a character array with the times of the trajectory in
#'  the form  c("MM-DD", "MM-DD")
#' @param fmt (character) ignored
#' @param url A URL for an ERDDAP server. Default:
#' https://upwell.pfeg.noaa.gov/erddap/ - See [rerddap::eurl()] for
#' more information
#' @param store ignored
#' @param read ignored
#' @param callopts Curl options passed on to \code{\link[crul]{verb-GET}}
#'
#' @return An object of class \code{griddap_csv} if csv chosen or
#' \code{griddap_nc} if nc file format chosen.
#' @export
#'
#' @examples
#' myURL <- "https://coastwatch.pfeg.noaa.gov/erddap/"
#' response <- try(httr::HEAD(myURL, httr::timeout(20)), silent = TRUE)
#' if (inherits(response, "try-error")) {
#'    message("The ERDDAP\u2122 server is not responding")
#' } else
#' {
#' data(wind_info)
#' season <- c('03-01', '03-04')
#' season_extract <- try(griddap_season(wind_info,
#'                                  time = c('2015-01-01','2016-01-01'),
#'                                  latitude = c(20, 21),
#'                                  longitude = c(220, 221),
#'                                  fields = 'mod_current',
#'                                  season = season
#'                                  ), silent = TRUE)
#' if (inherits(season_extract, "try-error")) {
#'    message("Unable to retrieve data from the ERDDAP\u2122 server")
#'    }
#'  }

griddap_season <- function(datasetx, ..., fields = 'all', stride = 1, season = NULL, fmt = "nc",
                          url = rerddap::eurl(), store = rerddap::disk(),
                          read = TRUE, callopts = list()) {

  x <- datasetx
  if (is.null(season)) {
    #print('no season is given')
    #print('this must be a vector length 2')
    #print('each element of is of form month-day')
    #stop('stopped on error')
    cli::cli_abort(c(
      "{.arg season} must be provided.",
      "i" = "It must be a vector of length 2.",
      "i" = "Each element should be of the form {.val month-day}."
    ))
  }
  dimargs <- list(...)
  if (length(dimargs) == 0) stop("no dimension arguments passed, see ?griddap")
  if (inherits(x, "info")) {
    url <- x$base_url
    message("info() output passed to x; setting base url to: ", url)
  } else {
    x <- rerddap::as.info(x, url)
  }
  if (attr(x, "type") != "griddap")
    stop("datasetid '", attr(x, "datasetid"), "' not of type griddap")
  check_dims(dimargs, x)
  if (!is.null(dimargs$time)) {
    check_time_range(dimargs, x)
  }
  call_list <- extract_rerddap_call(x, dimargs, stride, fields, url)
  dimargs <- call_list$dimargs
  dim_args <- call_list$dim_args
  dimVals <- call_list$dimVals
  url_base <- call_list$url_base
  fields <- call_list$fields
  extract <- griddap_season_request(x, url_base, dimargs, dim_args, fields, season)
  class(extract)  <- c("griddap_nc", "nc", "list")
  return(extract)
}

# 'griddap_season_request()' is a function to take the base 'rerddap::griddap()' type  request and
# loop over years to make an extract only for the given season and combine
# results into one griddap list.
# parameters:
#   info - result of call to rerddap::info
#   url_base - base url for griddap call
#   dimargs -
#   dim_args
#   fields - name or variables to include in extract
#   seasons - season of year to restrict request.
# return:
#   normal griddap structure combined over the seasons,
griddap_season_request <- function(info, url_base, dimargs, dim_args, fields, season) {
  start_year_dt <- lubridate::as_datetime(dimargs$time[1])
  end_year_dt <- lubridate::as_datetime(dimargs$time[2])
  start_year <- lubridate::year(start_year_dt)
  end_year <- lubridate::year(end_year_dt)
  years <- seq(start_year_dt, end_year_dt, 'years')
  CallOptsNames <- c('datasetx',  names(dimargs), 'fields')
  no_dims <- length(names(dimargs))
  extract <- NULL
  for (year_index in seq_along(years)) {
    my_year <- as.character(lubridate::year(years[year_index]))
    CallOpts <- list(info)
    temp_time1 <- paste0(my_year, '-', season[1])
    temp_time2 <- paste0(my_year, '-', season[2])
    my_time <- c(temp_time1, temp_time2)
    CallOpts$time <- my_time
    for (my_dim in names(dimargs)[2:no_dims]) {
      CallOpts[[my_dim]] <- dimargs[[my_dim]]
    }
    CallOpts$fields <- fields
    season_extract <- do.call(rerddap::griddap, CallOpts)
    if (is.null(extract)) {
      extract <- season_extract
    } else {
      extract$data <- rbind(extract$data, season_extract$data)
    }
  }
  return(extract)
}

#' rerddapUtils: Miscellaneous utilities for the  'rerddap' package.
#'
#' The 'rerddapUtils' package is an 'R' package that is a set of four main
#' functions designed to work with and extend the 'rerddap' package. These functions includes
#' one for restricting by season, one for splitting large requests,
#' and two for working with projected datasets. There are also two utility functions
#' that provide estimates of the size of a proposed 'rerddap::griddap()' request.
#'
#'
#' @section Main Functions:
#' \itemize{
#' \item \code{griddap_season} - Restricts the request to a given season during the year
#' \item \code{griddap_season} - Splits a large extract into smaller pieces
#' \item \code{xy_to_latlon} - Converts projected coordinates from an 'rerddap::griddap()' request
#'  to latitude-longitude coordinates
#' \item \code{latlon_to_xy} - Converts latitude-longitude coordinates to projected coordinates.
#' \item \code{estimate_griddap_size} - Estimates the size of a proposed 'rerddap::griddap()' request.
#' \item \code{estimate_griddap_split_size} - Estimates the size of a proposed split 'rerddap::griddap()' request.
#' }
#' @section Details:
#' Besides the terse help documents,  more  detail for using the
#' functions are given  in the included vignette "using-rerddapUtils".
#'
#' @docType package
#' @name rerddapUtils
#' @keywords internal
"_PACKAGE"
## usethis namespace: start
## usethis namespace: end
NULL

# Retrieve Dimension Values for a Dataset from an ERDDAP Server
#
# This function queries an ERDDAP server for the dimension values of a specified dataset.
# It constructs a request to the server without fetching the actual data (fields set to 'none' and read set to FALSE),
# aiming to retrieve metadata about the dataset dimensions. It is useful for understanding the range of
# values each dimension covers, such as time, depth, latitude, and longitude.
#
# @param x An object returned by `rerddap::info()` that contains metadata about the dataset,
#   including the base URL of the ERDDAP server and the dataset identifier.
# @param dimargs A list specifying the dimensions and their ranges for which to retrieve values.
#   Each element of the list should be named according to the dimension it represents.
#
# @return A list containing two elements: `dimVals`, a list of the retrieved dimension values,
#   where each element is named after a dimension and contains the values for that dimension;
#   and `nc_file`, a string indicating the filename of the NetCDF file that would contain the
#   data (if it were to be downloaded).
#
# @examples
# # Assuming `x` is a valid object returned by `rerddap::info()` for a dataset:
# dimargs <- list(time = c('2020-01-01', '2020-12-31'), depth = c(0, 100))
# dimVals <- get_dimVals(x, dimargs)
# print(dimVals$dimVals)
# print(dimVals$nc_file)
#
get_dimVals <- function(x, dimargs) {
  base_url <- paste0(x$base_url, '/')
  call_args <- list(datasetx = x)
  call_args <- c(call_args, dimargs)
#  for (i in seq_along(dimargs)){
#    call_args <- c(call_args, dimargs[i])
#    names(call_args)[i + 1] <- names(dimargs)[i]
#  }
  call_args$fields <- 'none'
  call_args$read <- FALSE
  call_args$url <- base_url
  temp_result <- do.call(rerddap::griddap, call_args)
  dimVals <- lapply(temp_result$summary$dim, `[[`, "vals")
#  dimVals = list()
#  for (i in seq_along(temp_result$summary$dim)){
#    temp <- temp_result$summary$dim[[i]]
#   dimVals[[temp$name]] <- temp$vals
#  }
  if ('time' %in% names(dimVals)) {
    dimVals$time <- as.character(as.POSIXlt(dimVals$time, origin = '1970-01-01', tz = "GMT"))
  }
  return(list(dimVals = dimVals, nc_file = temp_result$summary$filename))
}

# Prepare a Call to `rerddap::griddap()` for Data Retrieval
#
# This function constructs the necessary arguments for a `rerddap::griddap()` call to retrieve
# data from an ERDDAP server based on specified dimensions, stride, and fields. It checks and
# adjusts dimension arguments, validates data ranges for latitude and longitude, and builds
# a URL for the data request. This preparation includes parsing dimension arguments, handling
# field selections, and determining the correct endpoint URL.
#
# @param x An object returned by `rerddap::info()` that contains metadata about the dataset,
#   including the base URL of the ERDDAP server and the dataset identifier.
# @param dimargs A named list specifying the dimensions and their ranges for the data retrieval.
#   Each element of the list should be named according to the dimension it represents, and
#   contain the range of values to request for that dimension.
# @param stride An integer or named list specifying the stride (step size) for each dimension,
#   used to thin the data retrieval. For a single integer, the same stride is applied to all
#   dimensions.
# @param fields A character vector specifying which fields (variables) to retrieve from the
#   dataset. Can be a single variable name or 'all' for all available fields.
# @param url The base URL of the ERDDAP server from which to fetch the data.
#
# @return A list containing detailed information necessary for making a `rerddap::griddap()`
#   call, including adjusted dimension arguments, parsed dimension ranges, selected fields,
#   the base URL for the dataset, and the path to the NetCDF file that will contain the
#   downloaded data.
#
# @examples
# # Assuming `x` is an info object for a specific dataset on an ERDDAP server:
# dimargs <- list(time = c('2020-01-01', '2020-12-31'), latitude = c(-90, 90), longitude = c(-180, 180))
# stride <- 1
# fields <- 'all'
# url <- "https://example.erddap.server/erddap/"
#
# call_info <- extract_rerddap_call(x, dimargs, stride, fields, url)
# # call_info can now be used with `do.call(rerddap::griddap, call_info)` or similar logic.
#
extract_rerddap_call <- function(x, dimargs, stride, fields, url) {
  check_lat_text(dimargs)
  check_lon_text(dimargs)
  dimargs <- fix_dims(dimargs, .info = x)
  check_lon_data_range(dimargs, x)
  check_lat_data_range(dimargs, x)
  d <- attr(x, "datasetid")
  var <- field_handler(fields, x$variables$variable_name)
  dims <- dimvars(x)
  #store <- toggle_store(fmt, store)
  pargs <- sapply(dims, function(y) parse_args(x, y, stride, dimargs))
  dim_args <- list()
  for (i in seq_along(dims)){
    dim_args[[dims[i]]] <- paste0(dims[i], pargs[i])
  }
  #dim_args <- paste(temp_args, collapse = ',')
  #args <- lapply(dims, function(y) {
  #  paste0(y, paste0(pargs, collapse = ""))
  # })
  #fmt <- match.arg(fmt, c("nc", "csv"))
  fmt <- "nc"
  lenURL <- nchar(url)
  if (substr(url, lenURL, lenURL) != '/') {
    url <- paste0(url, '/')
  }
  url_base <- sprintf("%sgriddap/%s.%s", url, d, fmt)
  dimVals_extract <- get_dimVals(x, dimargs)
  dimVals <- dimVals_extract$dimVals
  nc_file <- dimVals_extract$nc_file
  call_info <- list(dimargs = dimargs, dim_args = dim_args,
                    dimVals = dimVals, url_base = url_base,
                    fields = var, nc_file = nc_file)
  return(call_info)
}



# Determine Split Indices for NetCDF File Dimensions
#
# This function calculates indices for splitting a NetCDF file into smaller segments along its
# dimensions (time, altitude, latitude, longitude). It's useful for segmenting large NetCDF files
# into more manageable pieces for analysis or for parallel processing tasks. The function
# determines the number of segments and the indices at which to split each dimension based on
# the provided split criteria.
#
# @param source_nc A list or object containing details about the NetCDF file's dimensions,
#   including the length (number of elements) of each dimension (time, altitude, latitude,
#   longitude).
# @param split A named list specifying the desired number of splits for each dimension.
#   The names of the list should correspond to the dimensions of the NetCDF file (e.g., time,
#   altitude, latitude, longitude).
#
# @return A list with two elements: `no_extract`, a data frame indicating the number of extracts
#   (segments) to be made for each dimension; and `dim_indices`, a data frame containing the
#   indices for each dimension at which the splits should occur. These indices can be used to
#   segment the NetCDF file into smaller pieces.
#
# @examples
# source_nc <- list(dim = list(time = list(len = 365),
#                             altitude = list(len = 10),
#                             latitude = list(len = 180),
#                             longitude = list(len = 360)))
# split_criteria <- list(time = 4, altitude = 1, latitude = 2, longitude = 2)
#
# split_info <- define_split_nc(source_nc, split_criteria)
# print(split_info$no_extract)
# print(split_info$dim_indices)
#
#define_split_nc <- function(source_nc, split){
#  no_time <- source_nc$dim[['time']]$len
#  no_altitude <- source_nc$dim[['altitude']]$len
#  no_latitude <- source_nc$dim[['latitude']]$len
#  no_longitude <- source_nc$dim[['longitude']]$len
#  indices <- split > 1
#  split[indices] <- unlist(split[indices]) + 1
#  time_indices <- as.integer(seq(1, no_time, length.out = split$time))
#  altitude_indices <-as.integer(seq(1, no_altitude, length.out = split$altitude))
#  latitude_indices <- as.integer(seq(1, no_latitude, length.out = split$latitude))
#  longitude_indices <- as.integer(seq(1, no_longitude,  length.out = split$longitude))
#  no_time_extracts <-  ifelse(length(time_indices) == 1, 1, length(time_indices) - 1)
#  no_altitude_extracts <-  ifelse(length(altitude_indices) == 1, 1, length(altitude_indices) - 1)
#  no_latitude_extracts <-  ifelse(length(latitude_indices) == 1, 1, length(latitude_indices) - 1)
#  no_longitude_extracts <-  ifelse(length(longitude_indices) == 1, 1, length(longitude_indices) - 1)
#  no_extracts <- data.frame(time = no_time_extracts,
#                            altitude = no_altitude_extracts,
#                            latitude = no_latitude_extracts,
#                            longitude = no_longitude_extracts
#  )
#  dim_indices <- data.frame(time = time_indices,
#                            altitude = altitude_indices,
#                            latitude = latitude_indices,
#                            longitude = longitude_indices
#  )
#  return(list(no_extract = no_extracts, dim_indices = dim_indices))
#}
define_split_nc <- function(source_nc, split) {

  # Get dimension names and lengths directly from source_nc
  dim_names <- names(source_nc$dim)
  #dim_lengths <- sapply(dim_names, function(d) source_nc$dim[[d]]$len)
  dim_lengths <- vapply(dim_names, function(d) source_nc$dim[[d]]$len,
                        FUN.VALUE = numeric(1))

  # For any dimension not specified in split, default to 1 (no split)
  split_vals <- stats::setNames(rep(1L, length(dim_names)), dim_names)
  split_vals[names(split)] <- unlist(split[names(split)])

  # Increment splits > 1 by 1 (to get correct boundary indices)
  split_vals[split_vals > 1] <- split_vals[split_vals > 1] + 1

  # Calculate indices for each dimension
  dim_indices_list <- lapply(dim_names, function(d) {
    as.integer(seq(1, dim_lengths[d], length.out = split_vals[d]))
  })
  names(dim_indices_list) <- dim_names

  # Calculate number of extracts per dimension
  no_extracts_list <- lapply(dim_names, function(d) {
    idx <- dim_indices_list[[d]]
    ifelse(length(idx) == 1, 1L, length(idx) - 1L)
  })
  names(no_extracts_list) <- dim_names

  # Pad shorter vectors with NA so data.frame() works when lengths differ
  # max_len <- max(sapply(dim_indices_list, length))
  max_len <- max(vapply(dim_indices_list, length, FUN.VALUE = integer(1)))
  dim_indices_padded <- lapply(dim_indices_list, function(x) {
    length(x) <- max_len
    x
  })

  return(list(
    no_extract  = as.data.frame(no_extracts_list),
    dim_indices = as.data.frame(dim_indices_padded)
  ))
}


# Create a New NetCDF File with Specified Fields from a Source File
#
# This function creates a new NetCDF file, copying dimensions from a source NetCDF file and
# including only the specified fields. It's useful for extracting a subset of variables from a
# large NetCDF file and saving them into a new file. The function handles the definition of
# dimensions and variables based on the source file and the provided field list, including units
# and data type precision for each field.
#
# @param data_info A data structure containing metadata about the variables to be included in the
#   new NetCDF file. This should include data types and units for each variable specified in `fields`.
# @param fields A vector of strings specifying the names of the variables to include in the new
#   NetCDF file. These should correspond to variable names in the source NetCDF file and the
#   `data_info` metadata.
# @param source_file A string specifying the path to the source NetCDF file from which dimensions
#   and variable metadata will be copied.
# @param destination_file A string specifying the path where the new NetCDF file will be created.
#
# @return This function does not return a value but creates a new NetCDF file at `destination_file`
#   containing the variables specified in `fields` with dimensions and metadata copied from
#   `source_file`.
#
# @examples
# data_info <- list(
#   alldata = list(
#     temperature = list(data_type = "double", attribute_name = c("units"), value = c("Celsius"))
#   )
# )
# fields <- c("temperature")
# source_file <- "path/to/source_file.nc"
# destination_file <- "path/to/destination_file.nc"
#
# create_nc_file(data_info, fields, source_file, destination_file)
# # This will create 'destination_file.nc' containing only the 'temperature' variable.
#

create_nc_file <- function(data_info, fields, source_file, destination_file) {
  source_nc <- ncdf4::nc_open(source_file)
  on.exit(ncdf4::nc_close(source_nc), add = TRUE)

  # Copy dimensions from source
  source_dim <- lapply(rev(source_nc$dim), function(d) {
    ncdf4::ncdim_def(d$name, d$units, d$vals)
  })

  # Define output variables
  source_var <- lapply(fields, function(var_name) {
    attrs <- data_info$alldata[[var_name]]
    ncdf4::ncvar_def(
      name    = var_name,
      units   = attrs$value[attrs$attribute_name == "units"],
      dim     = source_dim,
      missval = NA,
      prec    = attrs$data_type[1]
    )
  }) |> stats::setNames(fields)

  dest_nc <- ncdf4::nc_create(destination_file, vars = source_var, force_v4 = TRUE)
  on.exit(ncdf4::nc_close(dest_nc), add = TRUE)
}

# ----------------------------------------
# Function to copy attributes
# Copy Attributes from Source to Destination NetCDF File
#
# This function copies global attributes and specified variable attributes from a source NetCDF
# file to a destination NetCDF file. It is useful for replicating metadata when creating a new
# NetCDF file based on an existing file, ensuring that the new file retains relevant contextual
# information and variable-specific attributes.
#
# @param data_info A data structure containing metadata and attribute values for the variables
#   specified in `fields`. This metadata is used to copy variable-specific attributes to the
#   destination file.
# @param fields A vector of strings specifying the names of the variables for which attributes
#   should be copied from the source to the destination file. These should correspond to variable
#   names in both the source file and the `data_info` metadata structure.
# @param source_file A string specifying the path to the source NetCDF file from which attributes
#   will be copied.
# @param destination_file A string specifying the path to the destination NetCDF file where the
#   attributes will be copied to.
#
# @return This function does not return a value but modifies the destination NetCDF file by
#   copying attributes for global scope and for the specified variables from the source file.
#
# @examples
# data_info <- list(
#   alldata = list(
#     temperature = list(values = list(units = "Celsius", long_name = "Sea Surface Temperature")),
#     salinity = list(values = list(units = "PSU", long_name = "Sea Surface Salinity"))
#   )
# )
# fields <- c("temperature", "salinity")
# source_file <- "path/to/source_file.nc"
# destination_file <- "path/to/destination_file.nc"
#
# copy_attributes(data_info, fields, source_file, destination_file)
# # This will copy global attributes and attributes for 'temperature' and 'salinity' variables.
#

copy_attributes <- function(data_info, fields, source_file, destination_file) {
  source_nc <- ncdf4::nc_open(source_file)
  on.exit(ncdf4::nc_close(source_nc), add = TRUE)
  dest_nc <- ncdf4::nc_open(destination_file, write = TRUE)
  on.exit(ncdf4::nc_close(dest_nc), add = TRUE)

  # Copy global attributes from source
  global_attrs <- ncdf4::ncatt_get(source_nc, 0)
  lapply(names(global_attrs), function(attr_name) {
    ncdf4::ncatt_put(dest_nc, 0, attr_name, global_attrs[[attr_name]])
  })

  # Copy variable attributes from data_info (skipping first and _FillValue)
  lapply(fields, function(var_name) {
    var_attrs <- data_info$alldata[[var_name]]$values[-1]
    var_attrs <- var_attrs[names(var_attrs) != "_FillValue"]
    lapply(names(var_attrs), function(attr) {
      ncdf4::ncatt_put(dest_nc, var_name, attr, var_attrs[[attr]])
    })
  })

  invisible(NULL)
}





#############################
##  from package 'rerddap'
############################

field_handler <- function(x, y){
  x <- match.arg(x, c(y, "none", "all"), TRUE)
  if (length(x) == 1 && x == "all") {
    y
  } else if (all(x %in% y) || x == "none") {
    x
  }
}

check_dims <- function(dimargs, .info) {
  if (any(lengths(dimargs )!= 2)) {
    #print("All coordinate bounds must be of length 2, even if same value")
    #print("Present values are:")
    #print(dimargs)
    #stop("rerddap halted", call. = FALSE)
    cli::cli_abort(c(
      "All coordinate bounds must be of length 2, even if the same value.",
      "i" = "Present values: {.val {dimargs}}"
    ))
  }
  if (!all(names(dimargs) %in% dimvars(.info))) {
    stop(sprintf("Some input dimensions (%s) don't match those in dataset (%s)",
                 paste0(names(dimargs), collapse = ", "),
                 paste0(dimvars(.info), collapse = ", ")), call. = FALSE)
  }
}

check_lon_text <- function(dimargs) {
  if (!is.null(dimargs$longitude)) {
    #if (any(sapply(dimargs$longitude, class) == "character")) {
      #txt <- dimargs$longitude[sapply(dimargs$longitude, class) == "character"]
    if (any(vapply(dimargs$longitude, class, FUN.VALUE = character(1)) == "character")) {
      txt <- dimargs$longitude[vapply(dimargs$longitude, class,
                                        FUN.VALUE = character(1)) == "character"]
      if (!all(grepl("last", txt))) stop("Only text values allowed are 'last' & variants on that", call. = FALSE)
    }
  }
}

check_lat_text <- function(dimargs) {
  if (!is.null(dimargs$latitude)) {
    #if (any(sapply(dimargs$latitude, class) == "character")) {
      #txt <- dimargs$latitude[sapply(dimargs$latitude, class) == "character"]
    if (any(vapply(dimargs$latitude, class, FUN.VALUE = character(1)) == "character")) {
      txt <- dimargs$latitude[vapply(dimargs$latitude, class,
                                       FUN.VALUE = character(1)) == "character"]
      if (!all(grepl("last", txt))) stop("Only text values allowed are 'last' & variants on that", call. = FALSE)
    }
  }
}

is_lon_text <- function(dimargs) {
  if (!is.null(dimargs$longitude)) {
    #any(sapply(dimargs$longitude, class) == "character")
    any(vapply(dimargs$longitude, class, FUN.VALUE = character(1)) == "character")
  } else {
    FALSE
  }
}

is_lat_text <- function(dimargs) {
  if (!is.null(dimargs$latitude)) {
    # any(sapply(dimargs$latitude, class) == "character")
    any(vapply(dimargs$latitude, class, FUN.VALUE = character(1)) == "character")
  } else {
    FALSE
  }
}

check_time_range <- function(dimargs, x) {
  #  if(!class(dimargs$time) == 'character'){
  if(!is.character(dimargs$time)){
    print('time must be given as character strings')
    print('you are passing ', paste0(class(dimargs$time)))
    stop('rerddap halted', call. = FALSE)
  }
  global <- x$alldata$NC_GLOBAL
  tt <- global[ global$attribute_name %in%c('time_coverage_end','time_coverage_start'), "value", ]
  tt <- rev(tt)
  if (!('last' %in% dimargs$time)){
    if((dimargs$time[1] < tt[1]) | (dimargs$time[2] > tt[2])) {
      #print('time bounds are out of range')
      #print('You gave: ')
      #print(dimargs$time)
      #print("Dataset times are: ")
      #print(tt)
      #stop('rerddap halted', call. = FALSE)
      cli::cli_abort(c(
        "Requested time bounds are outside the dataset range.",
        "x" = "You requested: {.val {dimargs$time[1]}} to {.val {dimargs$time[2]}}.",
        "i" = "Dataset range: {.val {tt[1]}} to {.val {tt[2]}}."
      ))
    }
  }
}


check_lon_data_range <- function(dimargs, .info) {
  if (!is.null(dimargs$longitude)) {
    val <- .info$alldata$longitude[ .info$alldata$longitude$attribute_name == "actual_range", "value"]
    val2 <- as.numeric(strtrim(strsplit(val, ",")[[1]]))
    if (!is_lon_text(dimargs)) {
      if (max(dimargs$longitude) > max(val2) || min(dimargs$longitude) < min(val2)) {
        stop(sprintf("One or both longitude values (%s) outside data range (%s)",
                     paste0(dimargs$longitude, collapse = ", "),
                     paste0(val2, collapse = ", ")), call. = FALSE)
      }
    }
  }
}

check_lat_data_range <- function(dimargs, .info) {
  if (!is.null(dimargs$latitude)) {
    val <- .info$alldata$latitude[ .info$alldata$latitude$attribute_name == "actual_range", "value"]
    val2 <- as.numeric(strtrim(strsplit(val, ",")[[1]]))
    if (!is_lat_text(dimargs)) {
      if (max(dimargs$latitude) > max(val2) || min(dimargs$latitude) < min(val2)) {
        stop(sprintf("One or both latitude values (%s) outside data range (%s)",
                     paste0(dimargs$latitude, collapse = ", "),
                     paste0(val2, collapse = ", ")), call. = FALSE)
      }
    }
  }
}

fix_dims <- function(dimargs, .info) {
  for (i in seq_along(dimargs)) {
    tmp <- dimargs[[i]]
    nm <- names(dimargs[i])
    tmp <- grep("last+", tmp, value = TRUE, invert = TRUE)
    if (nm == "time") {
      tmp <- as.Date(tmp)
    }

    val <- .info$alldata[[nm]][ .info$alldata[[nm]]$attribute_name == "actual_range", "value"]
    temp_val <- strsplit(val, ",")[[1]]
    temp_val <- gsub("^\\s+|\\s+$", "", temp_val)
    val2 <- as.numeric(temp_val)
    # val2 <- as.numeric(strtrim(strsplit(val, ",")[[1]]))
    if (length(tmp) != 0) {
      if (which.min(val2) != which.min(tmp)) {
        dimargs[[i]] <- rev(dimargs[[i]])
      }
    }

    ## new
    # if (nm %in% c('latitude', 'longitude')) {
    if (nm != 'time') {
      z <- unlist(strsplit(.info$alldata[[nm]]$value[1], ","))
      spacing <- as.numeric(unlist(strsplit(z[3], "=")[[1]])[2])
      if ((!is.na(spacing)) & (spacing < 0)) {
        if (!(dimargs[[i]][1] > dimargs[[i]][2])) {
          dimargs[[i]] <- rev(dimargs[[i]])
        }
      }
    }
  }
  dimargs
}

parse_args <- function(.info, dim, s, dimargs, wname = FALSE){
  tmp <- if (dim %in% names(dimargs)) {
    dimargs[[dim]]
  } else {
    if (dim == "time") {
      times <- c(getvar(.info, "time_coverage_start"), getvar(.info, "time_coverage_end"))
      sprintf('[(%s):%s:(%s)]', times[1], s, times[2])
    } else {
      actrange <- foo(.info$alldata[[dim]], "actual_range")
      gsub("\\s+", "", strsplit(actrange, ",")[[1]])
    }
  }

  if (length(s) > 1) {
    if (!length(s) == length(dimvars(.info))) stop("Your stride vector must equal length of dimension variables", call. = FALSE)
    names(s) <- dimvars(.info)
    if (!wname) {
      sprintf('[(%s):%s:(%s)]', tmp[1], s[[dim]], tmp[2])
    } else {
      sprintf('%s[(%s):%s:(%s)]', dim, tmp[1], s[[dim]], tmp[2])
    }
  } else {
    if (!wname) {
      if (length(tmp) == 1) {
        tmp
      } else {
        sprintf('[(%s):%s:(%s)]', tmp[1], s, tmp[2])
      }
    } else {
      if (length(tmp) == 1) {
        tmp
      } else {
        sprintf('%s[(%s):%s:(%s)]', dim, tmp[1], s, tmp[2])
      }
    }
  }
}

getvar <- function(x, y){
  x$alldata$NC_GLOBAL[ x$alldata$NC_GLOBAL$attribute_name == y, "value"]
}

getvars <- function(x){
  vars <- names(x$alldata)
  vars[ !vars %in% c("NC_GLOBAL", "time", x$variables$variable_name) ]
}

getallvars <- function(x){
  vars <- names(x$alldata)
  vars[ !vars %in% "NC_GLOBAL" ]
}

dimvars <- function(x){
  vars <- names(x$alldata)
  vars[ !vars %in% c("NC_GLOBAL", x$variables$variable_name) ]
}

foo <- function(x, y){
  x[ x$attribute_name == y, "value"]
}

`%||%` <- function (x, y) {
  if (is.null(x) || length(x) == 0) y else x
}

strextract <- function(str, pattern) regmatches(str, regexpr(pattern, str))

strtrim <- function(str) gsub("^\\s+|\\s+$", "", str)

#' Estimate the size of a rerddap::griddap() request
#'
#' Uses coordinate metadata from an ERDDAP info() object to estimate how
#' many grid cells will be returned and the total uncompressed byte count for
#' each requested data variable.  No network request is made.
#'
#' Coordinate dimension names are taken directly from the info object using
#' the same logic as rerddap:::dimvars() — the set-difference between all
#' keys in info$alldata and the data variable names plus "NC_GLOBAL".  This
#' means any coordinate system works: geographic lat/lon, projected x/y,
#' sigma-layer depth, ROMS xi_rho/eta_rho, etc.
#'
#' Dimension constraints are passed via ... using the exact coordinate
#' variable names reported by the dataset, the same way griddap() accepts
#' them.  Each constraint is a numeric (or character for time) vector of
#' length 2: c(min, max).
#'
#' Spacing is resolved in this order for each dimension:
#'   1. User-supplied override in the spacing argument.
#'   2. For time: (t_max - t_min) / (nValues - 1) derived from the
#'      dimension's nValues row and actual_range attribute.  This correctly
#'      handles running composites where time steps are daily even though the
#'      composite window is e.g. 8 days.
#'   3. NC_GLOBAL attributes: geospatial_lat_resolution,
#'      geospatial_lon_resolution, time_coverage_resolution (ISO 8601).
#'   4. Coordinate variable attributes: point_spacing, resolution, spacing.
#'   5. For time: averageSpacing string from the nValues row as a last resort.
#'   6. If the constraint min == max the dimension contributes 1 point.
#'   7. Otherwise: NA — a warning is issued and 1 point is assumed.
#'
#' @param info    An object returned by rerddap::info().
#' @param ...     Named dimension constraints, one per coordinate variable to
#'                constrain.  Names must exactly match the coordinate variable
#'                names in the dataset (as returned by dimvars(info)).
#'                Each value is c(min, max); for time use ISO 8601 strings.
#' @param fields  Character vector of data variable names, or "all" (default).
#' @param stride  Integer scalar or named list of per-dimension stride values,
#'                using the same convention as griddap().  Default 1.
#' @param spacing Optional named list to override auto-detected spacing for
#'                one or more dimensions.  For time, supply seconds as
#'                time_sec (e.g. spacing = list(time_sec = 86400)).
#'                For other dimensions use the coordinate variable name
#'                (e.g. spacing = list(latitude = 0.01, xi_rho = 1)).
#' @param verbose Logical; print a formatted summary (default TRUE).
#'
#' @return Invisibly, a named list containing per-dimension point counts,
#'         spacing values, per-variable byte estimates, and total bytes.
#'
#' @examples
#' \dontrun{
#'   library(rerddap)
#'
#'   myURL <- "https://coastwatch.pfeg.noaa.gov/erddap/"
#'   response <- try(httr::HEAD(myURL, httr::timeout(10)), silent = TRUE)
#'   if (inherits(response, "try-error")) {
#'      stop("The ERDDAP\u2122 server is not responding")
#'   }
#'   info <- rerddap::info("erdMH1chla8day", url = myURL)
#'   estimate_griddap_size(info,
#'     latitude  = c(30, 50),
#'     longitude = c(-140, -110),
#'     time      = c("2020-01-01", "2020-12-31"))
#' }

estimate_griddap_size <- function(info,
                                  ...,
                                  fields  = "all",
                                  stride  = 1L,
                                  spacing = list(),
                                  verbose = TRUE) {

  # ── helpers ──────────────────────────────────────────────────────────────

  `%||%` <- function(a, b) if (!is.null(a)) a else b

  .attr <- function(var_name, attr_names) {
    if (!var_name %in% names(info$alldata)) return(NA_character_)
    df  <- info$alldata[[var_name]]
    for (a in attr_names) {
      val <- df$value[df$attribute_name == a]
      if (length(val) && !is.na(val[1L]) && nzchar(val[1L]))
        return(as.character(val[1L]))
    }
    NA_character_
  }

  .bytes <- function(dtype) {
    switch(tolower(as.character(dtype)),
           "float"   = , "float32" = , "real"    = 4L,
           "double"  = , "float64" = 8L,
           "int"     = , "int32"   = , "integer" = 4L,
           "short"   = , "int16"   = 2L,
           "byte"    = , "int8"    = , "ubyte"   = 1L,
           "long"    = , "int64"   = 8L,
           "ushort"  = , "uint16"  = 2L,
           "uint"    = , "uint32"  = 4L,
           "string"  = , "char"    = 1L,
           8L
    )
  }

  .fmt <- function(b) {
    if      (b < 1024^1) sprintf("%.1f B",  b)
    else if (b < 1024^2) sprintf("%.1f KB", b / 1024)
    else if (b < 1024^3) sprintf("%.1f MB", b / 1024^2)
    else                 sprintf("%.2f GB", b / 1024^3)
  }

  .iso_to_sec <- function(x) {
    if (is.null(x) || is.na(x) || !nzchar(x)) return(NA_real_)
    x <- trimws(as.character(x))
    if (!grepl("^P", x, ignore.case = TRUE)) return(NA_real_)
    body   <- sub("^P", "", x, ignore.case = TRUE)
    parts  <- strsplit(body, "T", fixed = TRUE)[[1L]]
    date_s <- parts[1L]
    time_s <- if (length(parts) > 1L) parts[2L] else ""
    rx <- function(s, unit) {
      m <- regmatches(s, regexpr(paste0("[0-9.]+(?=", unit, ")"), s, perl = TRUE))
      if (length(m)) as.numeric(m) else 0
    }
    out <- rx(date_s, "[Yy]") * 365.25 * 86400 +
      rx(date_s, "[Mm]") *  30.44 * 86400 +
      rx(date_s, "[Ww]") *      7 * 86400 +
      rx(date_s, "[Dd]") *          86400 +
      rx(time_s, "[Hh]") *           3600 +
      rx(time_s, "[Mm]") *             60 +
      rx(time_s, "[Ss]")
    if (out == 0) NA_real_ else out
  }

  ## Derive time spacing from (t_max - t_min) / (nValues - 1).
  ## This is the most reliable method: it reflects the actual number of time
  ## steps in the dataset regardless of whether the dataset is a running
  ## composite (daily steps) or a true N-day snapshot (N-day steps).
  .time_spacing_from_nvalues <- function(vname) {
    df <- info$alldata[[vname]]

    # nValues is in the row_type == "dimension" row
    dim_row <- df$value[df$row_type == "dimension"]
    if (!length(dim_row)) return(NA_real_)
    m <- regmatches(dim_row, regexpr("(?<=nValues=)[0-9]+", dim_row, perl = TRUE))
    if (!length(m)) return(NA_real_)
    nval <- as.integer(m)
    if (is.na(nval) || nval < 2L) return(NA_real_)

    # actual_range is "t_min, t_max" in seconds since epoch
    range_str <- df$value[df$attribute_name == "actual_range"]
    if (!length(range_str)) return(NA_real_)
    rng <- suppressWarnings(as.numeric(strsplit(range_str, ",\\s*")[[1L]]))
    if (length(rng) < 2L || any(is.na(rng))) return(NA_real_)

    span <- abs(rng[2L] - rng[1L])
    if (span == 0) return(NA_real_)
    span / (nval - 1L)
  }

  ## Parse ERDDAP averageSpacing string as a last resort,
  ## e.g. "nValues=890, evenlySpaced=false, averageSpacing=7 days 23h 40m 34s"
  .avg_spacing_to_sec <- function(vname) {
    df      <- info$alldata[[vname]]
    avg_str <- df$value[df$row_type == "dimension"]
    if (!length(avg_str)) return(NA_real_)
    m <- regmatches(avg_str, regexpr("averageSpacing=.+", avg_str))
    if (!length(m)) return(NA_real_)
    s    <- sub("averageSpacing=", "", m)
    pick <- function(pattern) {
      x <- regmatches(s, regexpr(pattern, s, perl = TRUE))
      if (length(x)) as.numeric(x) else 0
    }
    total <- pick("[0-9]+(?= days?)") * 86400 +
      pick("[0-9]+(?=h)")      *  3600 +
      pick("[0-9]+(?=m)")      *    60 +
      pick("[0-9]+(?=s)")
    if (total > 0) total else NA_real_
  }

  .stride_for <- function(dim_name) {
    s <- if (is.list(stride)) {
      stride[[dim_name]] %||% stride[["default"]] %||% 1L
    } else {
      as.integer(stride)
    }
    max(1L, as.integer(s))
  }

  # ── get dimension variable names ──────────────────────────────────────────
  dim_vars <- rerddap:::dimvars(info)

  if (length(dim_vars) == 0L)
    stop("No dimension variables found in info object. ",
         "Is this a griddap (not tabledap) dataset?")

  # ── collect and validate user dimension constraints ───────────────────────
  dimargs <- list(...)

  unknown <- setdiff(names(dimargs), dim_vars)
  if (length(unknown))
    warning("Dimension(s) not in dataset, ignoring: ",
            paste(unknown, collapse = ", "),
            "\n  Available: ", paste(dim_vars, collapse = ", "))

  dimargs <- dimargs[intersect(names(dimargs), dim_vars)]

  # ── detect whether a dimension is time-like ───────────────────────────────
  .is_time_dim <- function(vname) {
    if (tolower(vname) == "time") return(TRUE)
    units_val <- .attr(vname, "units")
    !is.na(units_val) && grepl("since", units_val, ignore.case = TRUE)
  }

  # ── resolve spacing for each dimension ───────────────────────────────────
  dim_spacing <- stats::setNames(lapply(dim_vars, function(vname) {

    ## 1. User override by coordinate name
    if (!is.null(spacing[[vname]]))
      return(list(value = abs(as.numeric(spacing[[vname]])), source = "user"))

    ## 2. Time dimension
    if (.is_time_dim(vname)) {
      if (!is.null(spacing[["time_sec"]]))
        return(list(value = as.numeric(spacing[["time_sec"]]),
                    source = "user (time_sec)"))

      # Primary: derive from (t_max - t_min) / (nValues - 1) — correctly
      # handles running composites with daily steps
      sec <- .time_spacing_from_nvalues(vname)
      if (!is.na(sec))
        return(list(value = sec, source = "nValues / actual_range"))

      # Secondary: NC_GLOBAL ISO 8601 duration
      raw <- .attr("NC_GLOBAL", c("time_coverage_resolution", "time_resolution"))
      sec <- .iso_to_sec(raw)
      if (!is.na(sec))
        return(list(value = sec, source = paste0("NC_GLOBAL (", raw, ")")))

      # Last resort: averageSpacing string in the nValues row
      sec <- .avg_spacing_to_sec(vname)
      if (!is.na(sec))
        return(list(value = sec, source = "dimension averageSpacing"))

      return(list(value = NA_real_, source = "unknown"))
    }

    ## 3. Latitude-like dimension
    if (grepl("^lat", tolower(vname))) {
      v <- suppressWarnings(as.numeric(.attr("NC_GLOBAL",
                                             c("geospatial_lat_resolution", "geospatial_lat_step"))))
      if (!is.na(v) && v > 0)
        return(list(value = abs(v), source = "NC_GLOBAL::geospatial_lat_resolution"))
    }

    ## 4. Longitude-like dimension
    if (grepl("^lon", tolower(vname))) {
      v <- suppressWarnings(as.numeric(.attr("NC_GLOBAL",
                                             c("geospatial_lon_resolution", "geospatial_lon_step"))))
      if (!is.na(v) && v > 0)
        return(list(value = abs(v), source = "NC_GLOBAL::geospatial_lon_resolution"))
    }

    ## 5. Generic: check coordinate variable's own attributes
    v <- suppressWarnings(as.numeric(.attr(vname,
                                           c("point_spacing", "resolution", "spacing",
                                             "geospatial_vertical_resolution"))))
    if (!is.na(v) && v > 0)
      return(list(value = abs(v), source = paste0(vname, "::point_spacing")))

    list(value = NA_real_, source = "unknown")
  }), dim_vars)

  # ── compute n_points for each constrained dimension ───────────────────────
  dim_npts <- stats::setNames(lapply(dim_vars, function(vname) {
    constraint <- dimargs[[vname]]
    if (is.null(constraint)) return(NA_integer_)

    if (length(constraint) != 2L)
      stop("Constraint for '", vname, "' must be c(min, max)")

    vals <- if (.is_time_dim(vname)) {
      as.numeric(as.POSIXct(constraint, tz = "UTC"))
    } else {
      as.numeric(constraint)
    }
    span <- abs(vals[2L] - vals[1L])
    if (span == 0) return(1L)

    sp <- dim_spacing[[vname]]$value
    if (is.na(sp) || sp <= 0) {
      warning("Spacing unknown for '", vname,
              "'; assuming 1 point. Use spacing = list(", vname,
              " = <value>) to override.")
      return(1L)
    }
    floor(span / sp) + 1L
  }), dim_vars)

  dim_npts_strided <- stats::setNames(lapply(dim_vars, function(vname) {
    n <- dim_npts[[vname]]
    if (is.na(n)) return(NA_integer_)
    ceiling(n / .stride_for(vname))
  }), dim_vars)

  constrained   <- dim_vars[!vapply(dim_npts, is.na, logical(1L))]
  unconstrained <- dim_vars[ vapply(dim_npts, is.na, logical(1L))]

  n_cells <- prod(unlist(dim_npts_strided[constrained]))

  # ── data variables ────────────────────────────────────────────────────────
  all_vars <- info$variables
  req_vars <- if (identical(fields, "all")) {
    all_vars
  } else {
    all_vars[all_vars$variable_name %in% fields, , drop = FALSE]
  }

  var_bytes <- stats::setNames(
    vapply(seq_len(nrow(req_vars)),
           function(i) as.numeric(n_cells) * .bytes(req_vars$data_type[i]),
           numeric(1L)),
    req_vars$variable_name)

  total_bytes <- sum(var_bytes)

  # ── verbose output ────────────────────────────────────────────────────────
  if (verbose) {
    dsid <- attr(info, "datasetid") %||% "(unknown)"
    sep  <- paste(rep("-", 65), collapse = "")
    cat("=== griddap request size estimate ===\n")
    cat("  Dataset  :", dsid, "\n")
    cat("  All dims :", paste(dim_vars, collapse = ", "), "\n\n")

    if (length(unconstrained))
      cat("  NOTE: unconstrained dim(s) not included in estimate:",
          paste(unconstrained, collapse = ", "), "\n\n")

    cat(sprintf("  %-20s  %10s  %10s  %s\n",
                "Dimension", "n_pts", "strided", "spacing / source"))
    cat(sep, "\n")
    for (vname in dim_vars) {
      n   <- dim_npts[[vname]]
      ns  <- dim_npts_strided[[vname]]
      sp  <- dim_spacing[[vname]]
      sp_str <- if (is.na(sp$value)) {
        paste0("unknown  [", sp$source, "]")
      } else if (.is_time_dim(vname)) {
        paste0(sp$value, " s  [", sp$source, "]")
      } else {
        paste0(sp$value, "  [", sp$source, "]")
      }
      cat(sprintf("  %-20s  %10s  %10s  %s\n",
                  vname,
                  if (is.na(n))  "(full)" else format(n,  big.mark = ","),
                  if (is.na(ns)) "(full)" else format(ns, big.mark = ","),
                  sp_str))
    }
    cat(sep, "\n")
    cat(sprintf("  Total cells (constrained) : %s\n\n",
                format(n_cells, big.mark = ",")))

    cat(sprintf("  %-30s  %-10s  %s\n", "Variable", "dtype", "size"))
    for (nm in names(var_bytes)) {
      dtype <- req_vars$data_type[req_vars$variable_name == nm]
      cat(sprintf("  %-30s  %-10s  %s\n", nm, dtype, .fmt(var_bytes[nm])))
    }
    cat(sep, "\n")
    cat(sprintf("  Estimated size (NetCDF3, no compression) : %s\n",
                .fmt(total_bytes)))
  }

  invisible(list(
    dim_vars         = dim_vars,
    constrained      = constrained,
    unconstrained    = unconstrained,
    dim_npts         = dim_npts,
    dim_npts_strided = dim_npts_strided,
    dim_spacing      = dim_spacing,
    n_cells          = n_cells,
    var_bytes        = var_bytes,
    total_bytes      = total_bytes,
    total_fmt        = .fmt(total_bytes)
  ))
}


#' Estimate the size of a single split in a rerddap::griddap() request
#'
#' Takes the result of estimate_griddap_size() together with a named list of
#' split counts per dimension and reports the estimated uncompressed size of
#' one split.  The total number of splits is the product of all split counts
#' (e.g. splits = list(time = 5, latitude = 2, longitude = 2) means 20 total
#' splits).  Per-split point counts use ceiling(n_pts / split_count) so
#' uneven divisions are handled correctly and estimates are conservative.
#'
#' @param size_est  The list returned invisibly by estimate_griddap_size().
#' @param splits    Named list of split counts per dimension.  Dimensions not
#'                  listed are assumed to have a split count of 1 (no split).
#' @param verbose   Logical; print a summary (default TRUE).
#'
#' @return Invisibly, a named list with the total split count, per-split cell
#'         count, per-variable byte estimates, total per-split bytes, and a
#'         formatted size string.
#'
#' @examples
#' \dontrun{
#'   library(rerddap)
#'
#'   myURL = 'https://coastwatch.pfeg.noaa.gov/erddap/'
#'   response <- try(httr::HEAD(myURL, httr::timeout(10)), silent = TRUE)
#'   if (inherits(response, "try-error")) {
#'      stop("The ERDDAP\u2122 server is not responding")
#'   }
#'   wind_info <- info("erdQMekm14day", url = myURL)
#'   sz <- estimate_griddap_size(wind_info,
#'     latitude  = c(20, 40),
#'     longitude = c(-140, -110),
#'     time      = c("2015-01-01", "2016-01-01"),
#'     fields    = "mod_current")
#'
#'   estimate_griddap_split_size(sz,
#'     splits = list(time = 5, altitude = 1, latitude = 2, longitude = 2))
#' }

estimate_griddap_split_size <- function(size_est,
                                        splits,
                                        verbose = TRUE) {

  .fmt <- function(b) {
    if      (b < 1024^1) sprintf("%.1f B",  b)
    else if (b < 1024^2) sprintf("%.1f KB", b / 1024)
    else if (b < 1024^3) sprintf("%.1f MB", b / 1024^2)
    else                 sprintf("%.2f GB", b / 1024^3)
  }

  dim_vars    <- size_est$dim_vars
  constrained <- size_est$constrained

  # ── split counts: default 1 for any dimension not listed ─────────────────
  split_counts <- stats::setNames(lapply(dim_vars, function(vname) {
    sv <- splits[[vname]]
    if (!is.null(sv) && as.numeric(sv) > 1) as.integer(sv) else 1L
  }), dim_vars)

  n_total_splits <- prod(unlist(split_counts[constrained]))

  # ── per-split point counts ────────────────────────────────────────────────
  split_npts <- stats::setNames(lapply(dim_vars, function(vname) {
    n  <- size_est$dim_npts_strided[[vname]]
    sc <- split_counts[[vname]]
    if (is.na(n)) return(NA_integer_)
    ceiling(n / sc)
  }), dim_vars)

  split_cells <- prod(unlist(split_npts[constrained]))

  # ── per-variable bytes for one split ─────────────────────────────────────
  split_var_bytes <- vapply(names(size_est$var_bytes), function(nm) {
    bytes_per_cell <- size_est$var_bytes[[nm]] / size_est$n_cells
    as.numeric(split_cells) * bytes_per_cell
  }, numeric(1L))

  split_total_bytes <- sum(split_var_bytes)

  # ── verbose output ────────────────────────────────────────────────────────
  if (verbose) {
    sep <- paste(rep("-", 65), collapse = "")
    cat("=== griddap split size estimate ===\n")
    cat(sprintf("  Total splits              : %d  (%s)\n",
                n_total_splits,
                paste(names(split_counts[constrained]),
                      unlist(split_counts[constrained]), sep = "=",
                      collapse = ", ")))
    cat(sprintf("  Cells per split           : %s\n",
                format(split_cells, big.mark = ",")))
    cat(sep, "\n")
    cat(sprintf("  Estimated size per split (NetCDF3, no compression) : %s\n",
                .fmt(split_total_bytes)))
  }

  invisible(list(
    n_total_splits    = n_total_splits,
    split_counts      = split_counts,
    split_npts        = split_npts,
    split_cells       = split_cells,
    split_var_bytes   = split_var_bytes,
    split_total_bytes = split_total_bytes,
    split_fmt         = .fmt(split_total_bytes)
  ))
}

#' Convert Projected 'rerddap::griddap()' Coordinates to Latitude-Longitude
#'
#' This function converts the projected coordinates from a 'rerddap::griddap()'
#' response into geographical coordinates (latitude and longitude).
#' It supports responses from `griddap`, `rxtracto`, and `rxtracto3D` by
#' detecting the response type and applying the appropriate
#' Coordinate Reference System (CRS) transformation.
#'
#' @param resp A response object from a call to `rerddap::griddap()`.
#'   It is expected to be of type `griddap_nc`, `rxtracto3D`, or `rxtractoTrack`,
#'   which contains the projected coordinate data along with metadata
#'   including the dataset's CRS.
#' @param yName The name of the variable in `resp` that represents
#'    the Y coordinate (typically latitude or northing). Defaults to 'cols'.
#' @param xName The name of the variable in `resp` that represents the X coordinate
#'   (typically longitude or easting). Defaults to 'rows'.
#' @param crs An optional CRS code to be used for the transformation.
#'   If a CRS is found in the  `resp` metadata this is ignored.
#'   CRS code should be a valid EPSG code (e.g., `4326` for WGS84) or a PROJ string.
#' @return A matrix with two columns (`longitude`, `latitude`) containing the geographic
#'   coordinates corresponding to the projected coordinates in the input `resp`. Each row
#'   in the matrix corresponds to a point in `resp`.
#'
#' @export
#'
#' @examples
#' rows <- c(300112.5, 250027.5)
#' cols <- c(-400282.5, -350197.5)
#' # myURL <- 'https://coastwatch.noaa.gov/erddap/'
#' # iceInfo <- rerddap::info('noaacwVIIRSn20icethickNP06Daily', url devtoo= myURL)
#' # proj_extract <- rerddap::griddap(iceInfo,
#' #                           time = c('2026-05-18T12:28:57Z', '2026-05-18T12:28:57Z'),
#' #                            rows = rows,
#' #                             cols = cols,
#' #                             altitude = c(0., 0.),
#' #                             fields = 'IceThickness',
#' #                            url = myURL
#' #
#' data(proj_extract)
#' test <- xy_to_latlon(proj_extract)
#'
xy_to_latlon <- function (resp, yName = 'cols', xName = 'rows', crs = NULL) {
  # Validate resp is from rerddap and extract necessary attributes
  if (!inherits(resp, c('griddap_nc', 'rxtracto', 'rxtracto3D', 'rxtractoTrack'))) {
    stop("The response object is not recognized. Please provide a valid 'griddap', 'rxtracto', 'rxtracto3D', or 'rxtractoTrack' object.")
  }

  url <- attributes(resp)$url
  datasetid <- attributes(resp)$datasetid
  base_loc <- stringr::str_locate(url, 'erddap')[1, 2]
  base_url <- substr(url, 1, (base_loc + 1))
  dataInfo <- rerddap::info(datasetid, url = base_url)

  proj_strings <- c('proj4text', 'projection', 'proj4string',
                    'grid_mapping_epsg_code', 'WKT',  'proj_crs_code',
                    'grid_mapping_epsg_code', 'grid_mapping_proj4',
                    'grid_mapping_proj4_params', 'grid_mapping_proj4text')
  # if crs is in extract use that
  crs_test <- intersect(proj_strings, dataInfo$alldata$NC_GLOBAL$attribute_name)
  if (length(crs_test) == 0) {
    # check if a crs is given
    if (!is.null(crs)) {
      proj_crs_code <- crs
    } else {
      #print('Could not find CRS information in the dataset and a CRS was not given')
      # stop('Please provide CRS information in the function call.')
      cli::cli_abort(c(
  "Could not find CRS information in the dataset and none was given.",
  "i" = "Provide CRS information in the function call."
))
    }
  } else {
    proj_crs_code_index <- match(crs_test, dataInfo$alldata$NC_GLOBAL$attribute_name)
    proj_crs_code <- dataInfo$alldata$NC_GLOBAL$value[proj_crs_code_index]
  }
  temp_df <- extract_grid_data(resp, xName, yName)

  # Convert grid data to spatial data frame and transform to lat-lon
  coordinates <- prepare_and_transform(temp_df, proj_crs_code[1],  'EPSG:4326')
  dimnames(coordinates)[[2]] <- c('longitude', 'latitude')
  coordinates
}

#' Convert Latitude-Longitude to Projected Coordinates
#'
#' This function converts geographic coordinates (latitude and longitude) into
#' projected coordinates based on a specified Coordinate Reference System (CRS).
#' The function can automatically detect the CRS from provided metadata (`dataInfo`)
#' or use a specified CRS code. It is designed to work with datasets obtained
#' from `rerddap::griddap()` but can be used with any geographic data that requires
#' coordinate transformation.
#'
#' @param dataInfo Metadata object containing CRS information, typically obtained
#'   from a `rerddap::info()` call on a dataset. It should include global attributes
#'   that contain CRS information.
#' @param latitude Numeric vector of latitudes to be converted.
#' @param longitude Numeric vector of longitudes to be converted.
#' @param yName Name of the latitude coordinate in the output projection. Defaults
#'   to 'latitude'.
#' @param xName Name of the longitude coordinate in the output projection. Defaults
#'   to 'longitude'.
#' @param crs Optional. A character string specifying the CRS to use for the
#'   projection. This can be an EPSG code (e.g., 'EPSG:4326' for WGS84) or a PROJ
#'   string. If NULL, the function attempts to detect the CRS from `dataInfo`.
#'
#' @return A matrix with columns corresponding to the projected x and y coordinates
#'   (in the order specified by `xName` and `yName`). Each row in the matrix
#'   corresponds to a pair of input latitude and longitude values.
#'
#' @export
#'
#' @examples
#' # myURL <- 'https://coastwatch.noaa.gov/erddap/'
#' # iceInfo <- rerddap::info('noaacwVIIRSn20icethickNP06Daily', url = myURL)
#' data(iceInfo)
#' latitude <- c( 80., 85.)
#' longitude <- c(-170., -165)
#' coords <- latlon_to_xy(iceInfo,  longitude, latitude)
#'
latlon_to_xy <- function (dataInfo, longitude, latitude,  xName = 'rows', yName = 'cols', crs = NULL) {
  proj_strings <- c('proj4text', 'projection', 'proj4string', 'grid_mapping_epsg_code',
                    'WKT',  'proj_crs_code',
                    'grid_mapping_epsg_code', 'grid_mapping_proj4',
                    'grid_mapping_proj4_params', 'grid_mapping_proj4text')

  # put lat-lon values into dataframe
  temp_df <- data.frame(longitude = longitude,  latitude = latitude)
  crs_given <- !is.null(crs)
  crs_test <- intersect(unlist(proj_strings),
                        unlist(dataInfo$alldata$NC_GLOBAL$attribute_name))
  crs_in_file <- length(crs_test) > 0

  # Initialize proj_crs_code
  proj_crs_code <- NULL

  # Determine CRS code from file if available
  if (crs_in_file) {
    proj_crs_code_index <- match(crs_test, dataInfo$alldata$NC_GLOBAL$attribute_name)
    proj_crs_code <- dataInfo$alldata$NC_GLOBAL$value[proj_crs_code_index]
  }

  # Handle different cases
  if (!crs_in_file && !crs_given) {
    #print("No CRS in file and no CRS given")
    #print("Look in dataset metadata for CRS information")
    #stop("Missing CRS information")
    cli::cli_abort(c(
       "Missing CRS information.",
        "i" = "No CRS found in file and none was provided.",
        "i" = "Check the dataset metadata for CRS information."
    ))
  } else if (crs_in_file && !crs_given) {
    # CRS in file, no CRS given
    coordinates <- prepare_and_transform(temp_df, 'EPSG:4326', proj_crs_code[1])
  } else if (crs_in_file && crs_given) {
    # CRS in file, CRS given
    crs_agree <- crs %in% proj_crs_code
    if (!crs_agree) {
      warning("The CRS given does not agree with the CRS in the file")
      warning(paste("The given CRS is", crs, "- the file CRS is", proj_crs_code[1]))
      warning('the file CRS will be used')
    }
    coordinates <- prepare_and_transform(temp_df, 'EPSG:4326', proj_crs_code[1])
  } else if (!crs_in_file && crs_given) {
    # No CRS in file, CRS given
    coordinates <- prepare_and_transform(temp_df, 'EPSG:4326', crs)
  }
  dimnames(coordinates)[[2]] <- c(xName, yName)
  return(coordinates)
}

# Extract grid data based on the type of response object
extract_grid_data <- function(resp, xName, yName) {
  if (inherits(resp, 'griddap_nc')) {
    data.frame(xgrid = resp$data[[xName]], ygrid = resp$data[[yName]])
  } else {
    data.frame(xgrid = resp[[xName]], ygrid = resp[[yName]])
  }
}


prepare_and_transform <- function(data_coords, crs_code_old, crs_code_new) {
  # Step 1: Convert the data frame to a simple feature (sf) object
  dimNames <- names(data_coords)
  temp_df <- sf::st_as_sf(data_coords,
                          coords = c(dimNames[1], dimNames[2]), crs = crs_code_old)
  # Step 2: Transform the coordinates to
  temp_df <- sf::st_transform(temp_df, crs = crs_code_new)
  # Step 3: Extract the transformed coordinates
  transformed_coords <- sf::st_coordinates(temp_df)
  return(transformed_coords)
}

#' Projected 14 day wind info
#'
#' \code{rerddap::info()} call to 14 day wind dataset
#'
#' @format A list of class \code{info} with elements:
#' \describe{
#'   \item{variables}{a data frame with a list of the variables in the extraction}
#'   \item{alldata}{metadata summary}
#'   \item{base_url}{a character string givng the base URL of the extract}
#' }
#' @source \url{https://coastwatch.noaa.gov/erddap/}
#' @docType data
#' @name wind_info
"wind_info"

---
title: "Using rerddapUtils"
output:
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 3
vignette: >
  %\VignetteIndexEntry{Using rerddapUtils}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup}
library(arrow)
library(dplyr)
library(duckdb)
library(duckplyr)
library(lubridate)
library(ncdf4)
library(rerddap)
library(rerddapUtils)
```
 
 The [R]{style="color:red"} package `rerddapUtils` is a set of four main functions designed to work extend the `rerddap` package to provide capabilities requested by users, and that meet specialized needs which are better dealt with in a separate package, and also provides two helper functions that estimate the size of a proposed `rerddap::griddap()` request.
 
 The first function `griddap_season()`:
 
- `griddap_season <- function(datasetx, ..., fields = 'all', stride = 1, season = NULL, fmt = "nc", url = eurl(), store = disk(), read = TRUE, callopts = list())`
                          
extracts data only for the period during the year defined by 'season'.  


The second function `griddap_split()`:
  
  
- `griddap_split <- function(datasetx, ..., fields = 'all', stride = 1, request_split = NULL, fmt = "nc", url = eurl(), store = disk(), read = TRUE, callopts = list(), aggregate_file = NULL)`
              
splits a very large request into pieces defined by 'request_split',  and then aggregates the parts either in memory,  in a duckdb database, or in a netcdf4 file.  This allows for requests larger than 2GB to be made in an appropriate manner.
 
Note that `griddap_season()` and `griddap_split()` are designed to mostly have the same interface as `rerddao::griddap()`,  except for one or two  additional function arguments.  Also some arguments are interpreted differently, such as in both functions the argument 'store = disk()' is ignored.  In `griddap_season()` the 'fmt' argument is ignored  while 'season' defines the days during the year to make the extract.

In  `griddap_split()` the argument 'fmt' defines whether the aggregate download should be stored in memory as a dataframe,  in a duckdb database file,  or in a netcdf4 file.  For the duckdb and nectdf4 options, 'aggregate_file' lets you define where to write the file.  If 'aggregate_file'  is not defined a temporary file is created following proper [R]{style="color:red"} guidelines, and in both cases the path to the file is returned.

The other two functions are designed to make it easier to work with projected datasets:

- `latlon_to_xy <- function (dataInfo, latitude, longitude, yName = 'latitude', xName = 'longitude', crs = NULL) `

which for a given dataset will convert a latitude and longitude request into the projected coordinates to be used in `rerddao::griddap()`, while the fourth function:

- `xy_to_latlon <- function (resp, yName = 'cols', xName = 'rows', crs = NULL)`

does the reverse,  given an `rerddao::griddap()` extract with projected coordinates, the coordinates are translated into latitude and longitude values.

The two helper functions work with  `rerddap::griddap()` and `griddap_split()`:

- `estimate_griddap_size <- function(info, ..., fields  = "all",cstride  = 1L, spacing = list(), verbose = TRUE)`

and 

- `estimate_griddap_split_size <- function(size_est, splits, verbose = TRUE)`

`estimate_griddap_size()` provides a rough estimate of the size  of a download from an `rerddap::griddap()` request,  and `estimate_griddap_split_size()` takes the output from '`estimate_griddap_size()` and estimates the size of the download for each request for a given split.


This vignette assumes familiarity with the various 'rerddap' functions and how to use them.  More information about the various 'rerddap' functions can be found in the documentation for that package.

## Extract during a season - `griddap_season()`

The function `griddap_season()` works exactly like the function `rerddap::griddap` except that there is one extra argument,  "season",  which restricts the extract to the part of the year defined by "season".  `griddap_season()` also ignores several of the `rerddap::griddap` options,  such as it ignores the "fmt" option,  and only saves to a standard `rerddap::griddap` output structure.

The argument "season" is a character string such that for a given "year",  `paste0(year, '-', season)` produces a valid ISO datetime string.  To test that  "season" is properly formed, use `lubridate::as_datetime()`:

```{r test_season_time}
year <- '2023'
season <- c('02-01', '06-01')
# test that "season" is defined properly
test_time <- paste0(year, '-', season)
lubridate::as_datetime(test_time)
```

The example only includes month and day,  but hours etc can be included as long as the final result,  when a year is appended,  produces a valid datetime.

As an example of using `griddap_season()` and how the function compares to using `rerddap::griddap()`, suppose for an `rerddap::griddap()` extract given by:

```{r wind_extract, eval=FALSE}
wind_info <- rerddap::info('erdQMekm14day')
extract <- rerddap::griddap(wind_info,
                            time = c('2015-01-01','2019-01-01'),
                            latitude = c(20, 40),
                            longitude = c(220, 240),
                            fields = 'mod_current'
)
```

it is desired to restrict the extract to March 1 to May 1 inclusive in each year.  Then the following modification of the above using `griddap_season()`produces the desired result:


```{r wind_season, eval = FALSE}
wcnURL <- "https://coastwatch.pfeg.noaa.gov/erddap/"
wind_info <- rerddap::info('erdQMekm14day', url = wcnURL)
season <- c('03-01', '05-01')
season_extract <- griddap_season(wind_info,
 time = c('2015-01-01','2019-01-01'),
 latitude = c(20, 40),
 longitude = c(220, 240),
 fields = 'mod_current',
 season = season
)

```

To check that the extract has been limited to the given season:

```{r season_months, eval = FALSE}
extract_times  <- lubridate::as_datetime(season_extract$data$time)
extract_months <- lubridate::month(extract_times)
unique(extract_months)
```

Only results for months 3, 4, and 5 are included,  as per the values of "season".  May is included  because the definition of "season" is inclusive,  hence May 1 will be included.

## Split an extract into parts - `griddap_split()`

The function `griddap_split()` allows for  `rerddap::griddap()` requests that are larger than the 2GB limit by splitting the request into parts and then combining the results either in memory, in a dataframe,  in a netcdf4 file,  or into a duckdb database file.  If the "in memory" option is chosen, there is no check that there is adequate memory,  so it is possible to crash both R and your computer. The nectdf4 and duckdb options depend more on having adequate disk space,  not memory. To check if the proposed split is small enough,  see `estimate_griddap_split_size()` below.

`griddap_split()` uses the same arguments as `rerddap::griddap()` except that:

- The "store" and "read" arguments are ignored.
- "fmt" is one of "memory", "nc", or "duckdb" - default "nc"
- an added argument "split"
- an added argument "aggregate_file" - default is to create an [R]{style="color:red"} temporary file

The argument "split" is a named list that defines the number of splits in each dimension,  not the values where to make the splits, and a value must be given for each coordinate in the dataset.  For the dataset 'erdQMekm14day' above,  there are four coordinates,  "time", "altitude", "latitude" and "longitude", so to break the request into five "time" parts and two "latitude" and "longitude" parts  (if you remember your combinatorics the original request will be broken into 20 separate requests) use:

```{r request_split}
request_split <- list(time = 5, altitude = 1, latitude = 2, longitude = 2)
```

Note that:

```{r request_split_fail, eval = FALSE}
request_split <- list(time = 5, latitude = 2, longitude = 2)
```

will fail,  even though "altitude" is dimension one.  A value must be given for all of the coordinates in the dataset.

"fmt" defines how the split extracts are combined to give one result.  If fmt = "memory"  then the results are combined into a usual `rerddap::griddap()` dataframe in memory,  and that structure is returned by the function.  If fmt = "nc" then the extracts are combined into a netcdf4 file,  and a path to the netcdf4 file is returned by the function. If fmt = "duckdb" then the extracts are combined into a duckdb database file,  and a path to the duckdb file is returned by the function.

As in the previous example, given a proposed `rerddap::griddap()` extract:

```{r wind_extract_redux, eval=FALSE}
wind_info <- rerddap::info('erdQMekm14day')
extract <- rerddap::griddap(wind_info,
                            time = c('2015-01-01','2016-01-01'),
                            latitude = c(20, 40),
                            longitude = c(220, 240),
                            fields = 'mod_current'
)
```

then the function `estimate_griddap_size()` provides a rough estimate of the size of the file to be downloaded,  (usually a bit on the low side,  but good enough to see if the download size approaches 2GB):

```{r wind_extract_size, eval = FALSE}
sz <- estimate_griddap_size(wind_info,
                            time = c('2015-01-01','2016-01-01'),
                            latitude = c(20, 40),
                            longitude = c(220, 240),
                            fields = 'mod_current',
)


```

In the example the  information is printed out and stored in the variable "sz",  when not set to a variable the information is just printed out.  In this case the download size would be about 13.5 MB.

To obtain an estimate of the download size of each file in a proposed split:

```{r wind_extract_split_size, eval = FALSE}
estimate_griddap_split_size(sz,
 splits = request_split
 )

```
and each split will be about 714KB in size.


Given that the requested splits are small enough, to make the request for the split "request_split" defined above and stored in memory:

```{r wind_split_memory, eval = FALSE}
wcnURL <- "https://coastwatch.pfeg.noaa.gov/erddap/"
wind_info <- rerddap::info('erdQMekm14day', url = wcnURL)
request_split <- list(time = 5, altitude = 1, latitude = 2, longitude = 2)
split_extract <- griddap_split(wind_info,
 time = c('2015-01-01','2016-01-01'),
 latitude = c(20, 40),
 longitude = c(220, 240),
 fields = 'mod_current',
 request_split = request_split,
 fmt = "memory"
)
str(split_extract)
```

On return, "split_extract" contains the usual `rerddap::griddap()` dataframe.  Again,  there is no check that there is enough memory to do this operation,  so it is possible to crash [R]{style="color:red"} (or your computer) if not used carefully. It is common  for computers these days to have 16GB of RAM or more,  so extracts a good bit larger than 2GB can be stored in memory.

If instead it is desired to store the result in a netcdf4 file:

```{r wind_split_nc, eval = FALSE}
wcnURL <- "https://coastwatch.pfeg.noaa.gov/erddap/"
wind_info <- rerddap::info('erdQMekm14day', url = wcnURL)
request_split <- list(time = 5, altitude = 1, latitude = 2, longitude = 2)
split_extract <- griddap_split(wind_info,
 time = c('2015-01-01','2016-01-01'),
 latitude = c(20, 40),
 longitude = c(220, 240),
 fields = 'mod_current',
 request_split = request_split,
 fmt = "nc"
)

```

The argument "aggregate_file" is not set in the example above, so the netcdf4 file is written to a temporary location and the path to that file returned by the function.  The reason for this is it is bad form for an [R]{style="color:red"} package to write to a user's space without permission (in fact it is prohibited by CRAN).  To set the location where the netcdf4 file is written,  set "aggregate_file" to the name of the file,  in which case the file is written in the present working directory,  or else set "aggregate_file" as the full path to the file.  As an example:

```{r wind_split_nc_named, eval=FALSE}

wind_info <- rerddap::info('erdQMekm14day')
request_split <- list(time = 5, altitude = 1, latitude = 2, longitude = 2)
split_extract <- griddap_split(wind_info,
 time = c('2015-01-01','2016-01-01'),
 latitude = c(20, 40),
 longitude = c(220, 240),
 fields = 'mod_current',
 request_split = request_split,
 fmt = "nc",
 aggregate_file = 'wind_extract.nc'
)

```

To access the data in the netcdf4 file, any of the various R packages that can read netcdf4 files can be used, but it is recommend to only use packages that can read in subsets of the file,  as the data may well be too large for memory.  For example, to open the the netcdf4 file created above using 'ncdf4' and viewing a summary:

```{r wind_split_read_nc, eval = FALSE}
wind_file <- ncdf4::nc_open(split_extract )
wind_file
ncdf4::nc_close(wind_file)

```


To make the same extract and save to a duckbb database file:

```{r wind_split_duckdb, eval = FALSE}

wind_info <- rerddap::info('erdQMekm14day')
request_split <- list(time = 5, altitude = 1, latitude = 2, longitude = 2)
split_extract <- griddap_split(wind_info,
 time = c('2015-01-01','2016-01-01'),
 latitude = c(20, 40),
 longitude = c(220, 240),
 fields = 'mod_current',
 request_split = request_split,
 fmt = "duckdb",
 aggregate_file = 'wind_extract.duckdb'
)

```


There are several packages that can read "duckdb" database files,  among them the packages 'dplyr' and 'duckplyr' (note extracts that write to a "duckdb" database file always write to a table named "extract":

```{r wind_split_read, eval = FALSE}
con_db <- dbConnect(duckdb::duckdb(), "wind_extract.duckdb")
tbl(con_db, "extract") |>
     head(5) |>
     collect()
dbDisconnect(con_db, shutdown=TRUE)
```


The default "duckdb" format is used because it allows for incremental additions to the dataset on disk,  so datasets can be larger than memory. A popular format for storing data is "parquet", or if it is desired to encode geometry information into the data,  then the "geoparquet" format.  To copy the duckdb file to parquet:

```{r wind_split_parquet, eval = FALSE}
con_db <- dbConnect(duckdb::duckdb(), "wind_extract.duckdb")
# Use DuckDB's COPY command to write directly to Parquet file without loading into R
query <- sprintf("COPY extract TO '%s' (FORMAT 'parquet')", "wind_extract.parquet")
DBI::dbExecute(con_db, query)
dbDisconnect(con_db, shutdown=TRUE)
```


The resulting parquet files are half the size of the duckdb file,  or smaller.  While these examples are for writing the duckdb database to the parquet format,  similar steps can be used if the data are in tibbles,  but it may require reading the entire dataset into memory.

## Working with projected datasets - `latlon_to_xy()` and `xy_to_latlon()`


Extracting projected data in ERDDAP™  (that is not on a latitude-longitude grid) can be difficult because most people do not think in terms of the projection in defining the region to make an extract,  and similary once an extract has been made,  it is often desirable to know the coordinates in terms of latitude and longitude.  The functions `latlon_to_xy()` and `xy_to_latlon()` are designed to help with this process.

In both cases the functions try to determine the dataset projection either from the dataset summary given by `rerddap::info()` when projecting the values of a latitude-longitude bounding box,  or when an extract has been made, from the metadata in the extract.  This is done by searching for any of the terms:

```{r proj_strings, eval = FALSE}
   proj_strings <- c('proj4text', 'projection', 'proj4string', 'grid_mapping_epsg_code',
                    'WKT',  'proj_crs_code',
                    'grid_mapping_epsg_code', 'grid_mapping_proj4',
                    'grid_mapping_proj4_params', 'grid_mapping_proj4text')

```

in the metadata.  If this is not found,  then the user has to provide the  "CRS",  which can be in any of the forms above. For example the Ice dataset 'nsidcG02202v4sh1day' on the Coastwatch Central ERDDAP™ is projected. The bounding box of interest is:

```{r bounding_box}
latitude <- c( 80., 85.)
longitude <- c(-170., -165)

```

then the bounding box in projected coordinates is found from:

```{r latlon_to_xy, eval = FALSE}
myURL <- 'https://coastwatch.noaa.gov/erddap/'
myInfo <- rerddap::info('noaacwVIIRSn20icethickNP06Daily', url = myURL)
coords <- latlon_to_xy(myInfo,  longitude, latitude)
coords
```

Similary,  given an extract on a projected coordinate system, the values on terms of latitude and longitude can be found by:

```{r xy_to_latlon, eval = FALSE} 
rows <- c( -889533.8, -469356.9)
cols <- c(622858.3, 270983.4)
myURL <- 'https://coastwatch.noaa.gov/erddap/'
myInfo <- rerddap::info('noaacwVIIRSn20icethickNP06Daily', url = myURL)
proj_extract <- rerddap::griddap(myInfo,
                                  time = c('2023-01-30T00:00:00Z', '2023-01-30T00:00:00Z'),
                                  rows = rows,
                                  cols = cols,
                                  fields = 'IceThickness',
                                  url = myURL
  )
test <- xy_to_latlon(proj_extract)
head(test)

```


Note that `xy_to_latlon()` also works with the output from the functions `rerddapXtracto::rxtracto()`, `rerddapXtracto::rxtracto_3D() ` and ``rerddapXtracto::rxtractogon()`.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/estimate_griddap_size.R
\name{estimate_griddap_size}
\alias{estimate_griddap_size}
\title{Estimate the size of a rerddap::griddap() request}
\usage{
estimate_griddap_size(
  info,
  ...,
  fields = "all",
  stride = 1L,
  spacing = list(),
  verbose = TRUE
)
}
\arguments{
\item{info}{An object returned by rerddap::info().}

\item{...}{Named dimension constraints, one per coordinate variable to
constrain.  Names must exactly match the coordinate variable
names in the dataset (as returned by dimvars(info)).
Each value is c(min, max); for time use ISO 8601 strings.}

\item{fields}{Character vector of data variable names, or "all" (default).}

\item{stride}{Integer scalar or named list of per-dimension stride values,
using the same convention as griddap().  Default 1.}

\item{spacing}{Optional named list to override auto-detected spacing for
one or more dimensions.  For time, supply seconds as
time_sec (e.g. spacing = list(time_sec = 86400)).
For other dimensions use the coordinate variable name
(e.g. spacing = list(latitude = 0.01, xi_rho = 1)).}

\item{verbose}{Logical; print a formatted summary (default TRUE).}
}
\value{
Invisibly, a named list containing per-dimension point counts,
spacing values, per-variable byte estimates, and total bytes.
}
\description{
Uses coordinate metadata from an ERDDAP info() object to estimate how
many grid cells will be returned and the total uncompressed byte count for
each requested data variable.  No network request is made.
}
\details{
Coordinate dimension names are taken directly from the info object using
the same logic as rerddap:::dimvars() — the set-difference between all
keys in info$alldata and the data variable names plus "NC_GLOBAL".  This
means any coordinate system works: geographic lat/lon, projected x/y,
sigma-layer depth, ROMS xi_rho/eta_rho, etc.

Dimension constraints are passed via ... using the exact coordinate
variable names reported by the dataset, the same way griddap() accepts
them.  Each constraint is a numeric (or character for time) vector of
length 2: c(min, max).

Spacing is resolved in this order for each dimension:
\enumerate{
\item User-supplied override in the spacing argument.
\item For time: (t_max - t_min) / (nValues - 1) derived from the
dimension's nValues row and actual_range attribute.  This correctly
handles running composites where time steps are daily even though the
composite window is e.g. 8 days.
\item NC_GLOBAL attributes: geospatial_lat_resolution,
geospatial_lon_resolution, time_coverage_resolution (ISO 8601).
\item Coordinate variable attributes: point_spacing, resolution, spacing.
\item For time: averageSpacing string from the nValues row as a last resort.
\item If the constraint min == max the dimension contributes 1 point.
\item Otherwise: NA — a warning is issued and 1 point is assumed.
}
}
\examples{
\dontrun{
  library(rerddap)

  myURL <- "https://coastwatch.pfeg.noaa.gov/erddap/"
  response <- try(httr::HEAD(myURL, httr::timeout(10)), silent = TRUE)
  if (inherits(response, "try-error")) {
     stop("The ERDDAP\u2122 server is not responding")
  }
  info <- rerddap::info("erdMH1chla8day", url = myURL)
  estimate_griddap_size(info,
    latitude  = c(30, 50),
    longitude = c(-140, -110),
    time      = c("2020-01-01", "2020-12-31"))
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rerddapUtils.R
\docType{package}
\name{rerddapUtils}
\alias{rerddapUtils-package}
\alias{rerddapUtils}
\title{rerddapUtils: Miscellaneous utilities for the  'rerddap' package.}
\description{
The 'rerddapUtils' package is an 'R' package that is a set of four main
functions designed to work with and extend the 'rerddap' package. These functions includes
one for restricting by season, one for splitting large requests,
and two for working with projected datasets. There are also two utility functions
that provide estimates of the size of a proposed 'rerddap::griddap()' request.
}
\section{Main Functions}{

\itemize{
\item \code{griddap_season} - Restricts the request to a given season during the year
\item \code{griddap_season} - Splits a large extract into smaller pieces
\item \code{xy_to_latlon} - Converts projected coordinates from an 'rerddap::griddap()' request
to latitude-longitude coordinates
\item \code{latlon_to_xy} - Converts latitude-longitude coordinates to projected coordinates.
\item \code{estimate_griddap_size} - Estimates the size of a proposed 'rerddap::griddap()' request.
\item \code{estimate_griddap_split_size} - Estimates the size of a proposed split 'rerddap::griddap()' request.
}
}

\section{Details}{

Besides the terse help documents,  more  detail for using the
functions are given  in the included vignette "using-rerddapUtils".
}

\author{
\strong{Maintainer}: Roy Mendelssohn \email{roy.mendelssohn@noaa.gov}

Authors:
\itemize{
  \item Roy Mendelssohn \email{roy.mendelssohn@noaa.gov}
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/estimate_griddap_size.R
\name{estimate_griddap_split_size}
\alias{estimate_griddap_split_size}
\title{Estimate the size of a single split in a rerddap::griddap() request}
\usage{
estimate_griddap_split_size(size_est, splits, verbose = TRUE)
}
\arguments{
\item{size_est}{The list returned invisibly by estimate_griddap_size().}

\item{splits}{Named list of split counts per dimension.  Dimensions not
listed are assumed to have a split count of 1 (no split).}

\item{verbose}{Logical; print a summary (default TRUE).}
}
\value{
Invisibly, a named list with the total split count, per-split cell
count, per-variable byte estimates, total per-split bytes, and a
formatted size string.
}
\description{
Takes the result of estimate_griddap_size() together with a named list of
split counts per dimension and reports the estimated uncompressed size of
one split.  The total number of splits is the product of all split counts
(e.g. splits = list(time = 5, latitude = 2, longitude = 2) means 20 total
splits).  Per-split point counts use ceiling(n_pts / split_count) so
uneven divisions are handled correctly and estimates are conservative.
}
\examples{
\dontrun{
  library(rerddap)

  myURL = 'https://coastwatch.pfeg.noaa.gov/erddap/'
  response <- try(httr::HEAD(myURL, httr::timeout(10)), silent = TRUE)
  if (inherits(response, "try-error")) {
     stop("The ERDDAP\u2122 server is not responding")
  }
  wind_info <- info("erdQMekm14day", url = myURL)
  sz <- estimate_griddap_size(wind_info,
    latitude  = c(20, 40),
    longitude = c(-140, -110),
    time      = c("2015-01-01", "2016-01-01"),
    fields    = "mod_current")

  estimate_griddap_split_size(sz,
    splits = list(time = 5, altitude = 1, latitude = 2, longitude = 2))
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wind_info.R
\docType{data}
\name{wind_info}
\alias{wind_info}
\title{Projected 14 day wind info}
\format{
A list of class \code{info} with elements:
\describe{
\item{variables}{a data frame with a list of the variables in the extraction}
\item{alldata}{metadata summary}
\item{base_url}{a character string givng the base URL of the extract}
}
}
\source{
\url{https://coastwatch.noaa.gov/erddap/}
}
\usage{
wind_info
}
\description{
\code{rerddap::info()} call to 14 day wind dataset
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/conversion.R
\name{latlon_to_xy}
\alias{latlon_to_xy}
\title{Convert Latitude-Longitude to Projected Coordinates}
\usage{
latlon_to_xy(
  dataInfo,
  longitude,
  latitude,
  xName = "rows",
  yName = "cols",
  crs = NULL
)
}
\arguments{
\item{dataInfo}{Metadata object containing CRS information, typically obtained
from a \code{rerddap::info()} call on a dataset. It should include global attributes
that contain CRS information.}

\item{longitude}{Numeric vector of longitudes to be converted.}

\item{latitude}{Numeric vector of latitudes to be converted.}

\item{xName}{Name of the longitude coordinate in the output projection. Defaults
to 'longitude'.}

\item{yName}{Name of the latitude coordinate in the output projection. Defaults
to 'latitude'.}

\item{crs}{Optional. A character string specifying the CRS to use for the
projection. This can be an EPSG code (e.g., 'EPSG:4326' for WGS84) or a PROJ
string. If NULL, the function attempts to detect the CRS from \code{dataInfo}.}
}
\value{
A matrix with columns corresponding to the projected x and y coordinates
(in the order specified by \code{xName} and \code{yName}). Each row in the matrix
corresponds to a pair of input latitude and longitude values.
}
\description{
This function converts geographic coordinates (latitude and longitude) into
projected coordinates based on a specified Coordinate Reference System (CRS).
The function can automatically detect the CRS from provided metadata (\code{dataInfo})
or use a specified CRS code. It is designed to work with datasets obtained
from \code{rerddap::griddap()} but can be used with any geographic data that requires
coordinate transformation.
}
\examples{
# myURL <- 'https://coastwatch.noaa.gov/erddap/'
# iceInfo <- rerddap::info('noaacwVIIRSn20icethickNP06Daily', url = myURL)
data(iceInfo)
latitude <- c( 80., 85.)
longitude <- c(-170., -165)
coords <- latlon_to_xy(iceInfo,  longitude, latitude)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/proj_extract.R
\docType{data}
\name{proj_extract}
\alias{proj_extract}
\title{Projected ice dataset response}
\format{
A list of class \code{griddap_nc} with elements:
\describe{
\item{data}{a data frame of the extracted ice values}
\item{summary}{metadata summary}
}
}
\source{
\url{https://coastwatch.noaa.gov/erddap/}
}
\usage{
proj_extract
}
\description{
\code{rerddap::griddap()} call to Projected ice dataset
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/conversion.R
\name{xy_to_latlon}
\alias{xy_to_latlon}
\title{Convert Projected 'rerddap::griddap()' Coordinates to Latitude-Longitude}
\usage{
xy_to_latlon(resp, yName = "cols", xName = "rows", crs = NULL)
}
\arguments{
\item{resp}{A response object from a call to \code{rerddap::griddap()}.
It is expected to be of type \code{griddap_nc}, \code{rxtracto3D}, or \code{rxtractoTrack},
which contains the projected coordinate data along with metadata
including the dataset's CRS.}

\item{yName}{The name of the variable in \code{resp} that represents
the Y coordinate (typically latitude or northing). Defaults to 'cols'.}

\item{xName}{The name of the variable in \code{resp} that represents the X coordinate
(typically longitude or easting). Defaults to 'rows'.}

\item{crs}{An optional CRS code to be used for the transformation.
If a CRS is found in the  \code{resp} metadata this is ignored.
CRS code should be a valid EPSG code (e.g., \code{4326} for WGS84) or a PROJ string.}
}
\value{
A matrix with two columns (\code{longitude}, \code{latitude}) containing the geographic
coordinates corresponding to the projected coordinates in the input \code{resp}. Each row
in the matrix corresponds to a point in \code{resp}.
}
\description{
This function converts the projected coordinates from a 'rerddap::griddap()'
response into geographical coordinates (latitude and longitude).
It supports responses from \code{griddap}, \code{rxtracto}, and \code{rxtracto3D} by
detecting the response type and applying the appropriate
Coordinate Reference System (CRS) transformation.
}
\examples{
rows <- c(300112.5, 250027.5)
cols <- c(-400282.5, -350197.5)
# myURL <- 'https://coastwatch.noaa.gov/erddap/'
# iceInfo <- rerddap::info('noaacwVIIRSn20icethickNP06Daily', url devtoo= myURL)
# proj_extract <- rerddap::griddap(iceInfo,
#                           time = c('2026-05-18T12:28:57Z', '2026-05-18T12:28:57Z'),
#                            rows = rows,
#                             cols = cols,
#                             altitude = c(0., 0.),
#                             fields = 'IceThickness',
#                            url = myURL
#
data(proj_extract)
test <- xy_to_latlon(proj_extract)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/griddap_season.R
\name{griddap_season}
\alias{griddap_season}
\title{Title Get ERDDAP gridded data restricted to a given season of the year}
\usage{
griddap_season(
  datasetx,
  ...,
  fields = "all",
  stride = 1,
  season = NULL,
  fmt = "nc",
  url = rerddap::eurl(),
  store = rerddap::disk(),
  read = TRUE,
  callopts = list()
)
}
\arguments{
\item{datasetx}{Anything coercable to an object of class info. So the output of a
call to \code{\link[rerddap]{info}}, or a datasetid, which will internally be passed
through \code{\link[rerddap]{info}}}

\item{...}{Dimension arguments. See examples. Can be any 1 or more of the
dimensions for the particular dataset - and the dimensions vary by dataset.
For each dimension, pass in a vector of length two, with min and max value
desired. at least 1 required.}

\item{fields}{(character) Fields to return, in a character vector.}

\item{stride}{(integer) How many values to get. 1 = get every value, 2 = get every other value, etc.
Default: 1 (i.e., get every value)}

\item{season}{(character) a character array with the times of the trajectory in
the form  c("MM-DD", "MM-DD")}

\item{fmt}{(character) ignored}

\item{url}{A URL for an ERDDAP server. Default:
https://upwell.pfeg.noaa.gov/erddap/ - See \code{\link[rerddap:eurl]{rerddap::eurl()}} for
more information}

\item{store}{ignored}

\item{read}{ignored}

\item{callopts}{Curl options passed on to \code{\link[crul]{verb-GET}}}
}
\value{
An object of class \code{griddap_csv} if csv chosen or
\code{griddap_nc} if nc file format chosen.
}
\description{
\code{griddap_season} uses the R program 'rerddap::griddap()' to extract environmental data
from an 'ERDDAP' server in an (time, z, y ,x) bounding box where time is restricted to a
given season of the year  (see below).  Arguments are the same in 'rerddap::griddap()'
except for the added 'season' parameter.  'read' and 'fmt' options are ignored.
}
\examples{
myURL <- "https://coastwatch.pfeg.noaa.gov/erddap/"
response <- try(httr::HEAD(myURL, httr::timeout(20)), silent = TRUE)
if (inherits(response, "try-error")) {
   message("The ERDDAP\u2122 server is not responding")
} else
{
data(wind_info)
season <- c('03-01', '03-04')
season_extract <- try(griddap_season(wind_info,
                                 time = c('2015-01-01','2016-01-01'),
                                 latitude = c(20, 21),
                                 longitude = c(220, 221),
                                 fields = 'mod_current',
                                 season = season
                                 ), silent = TRUE)
if (inherits(season_extract, "try-error")) {
   message("Unable to retrieve data from the ERDDAP\u2122 server")
   }
 }
}
